{*******************************************************************************
 *                               Liste Version 2.4                             *
 *                (c) 2002 Klaus Dingemann und Ulrich Borghoff                 *
 *                           eMail: sum-delphi@web.de                          *
 * *****************************************************************************
 * Beachten Sie bitte, dass es sich hier um ein vllig neues Modul handelt,    *
 * die nicht zur Version vom Oktober 2002 kompatibel ist.                      *
 *                                                                             *
 * Bitte ndern Sie diese Datei nicht ab, sondern teilen den Entwicklern Ihre  *
 * Verbesserungsvorschlge oder Fehler (und ggf. deren Berichtigung) mit.      *
 *                                                                             *
 * Fr den Unterricht sollten Sie nur die mListe.dcu Datei verwenden. Diese    *
 * muss sich im Ordner ..delphi/lib befinden. Die Angabe "uses mListe" ist     *
 * dann schon ausreichend.                                                     *
 *                                                                             *
 * Danke fr Ihre Mitarbeit.                                                   *
 *******************************************************************************}
// letzte nderung: 15.02.06 Joachim Deckers


unit mListe;

interface

type
  Knoten=class(tObject)
  private
    kenntInhalt:tObject;
    kenntNachfolger, kenntVorgaenger:Knoten;
  public
    constructor init(pInhalt:tObject;pVorgaenger, pNachfolger:Knoten);
    function inhalt:tObject;
    function vorgaenger:Knoten;
    function nachfolger:Knoten;
    function hatNachfolger:boolean;
    function hatVorgaenger:boolean;
    procedure setzeInhalt(pInhalt:tObject);
    procedure setzeVorgaenger(pVorgaenger:Knoten);
    procedure setzeNachfolger(pNachfolger:Knoten);
    destructor gibFrei;
  end;

  Liste=class(tObject)
  private
    hatAnfang, hatAktuelles, hatAnker:Knoten;
    zLaenge:integer;
  public
    constructor init; virtual;
    procedure fuegeDavorEin(pInhalt:tObject); virtual;
    procedure fuegeDahinterEin(pInhalt:tObject); virtual;
    procedure haengeAn(pInhalt:tObject); virtual;
    procedure setzeDavor(pInhalt:tObject); virtual;
    procedure ersetzeAktuelles(pInhalt:tObject); virtual;
    procedure entferneAktuelles; overload; virtual;
    procedure entferneAktuelles(mitInhalt:boolean); overload; virtual;
    procedure vor; virtual;
    procedure zurueck; virtual;
    procedure zumAnfang; virtual;
    procedure zumEnde; virtual;
    function istAmAnfang:boolean; virtual;
    function istAmEnde:boolean; virtual;
    function aktuelles:tObject; virtual;
    function istLeer:boolean; virtual;
    function istDavor:boolean; virtual;
    function istDahinter:boolean; virtual;
    function laenge:integer; virtual;
    procedure haengeListeAn(pListe:Liste);
    procedure setzeListeDavor(pListe:Liste);
    destructor gibFrei; overload; virtual;
    destructor gibFrei(pMitInhalt: boolean); overload; virtual;
    end;


implementation

  constructor Knoten.init(pInhalt:tObject;pVorgaenger, pNachfolger:Knoten);
  begin
    kenntInhalt:=pInhalt;
    kenntNachfolger:=pNachfolger;
    kenntVorgaenger:=pVorgaenger;
  end;

  function Knoten.inhalt:tObject;
  begin
    result:=kenntInhalt;
  end;

  function Knoten.nachfolger:Knoten;
  begin
    result:=kenntNachfolger;
  end;

  function Knoten.vorgaenger:Knoten;
  begin
    result:=kenntVorgaenger;
  end;

  function Knoten.hatNachfolger:boolean;
  begin
    result:=kenntNachfolger<>nil;
  end;

  function Knoten.hatVorgaenger:boolean;
  begin
    result:=kenntVorgaenger<>nil;
  end;

  procedure Knoten.setzeInhalt(pInhalt:tObject);
  begin
    kenntInhalt:=pInhalt;
  end;

  procedure Knoten.setzeNachfolger(pNachfolger:Knoten);
  begin
    kenntNachfolger:=pNachfolger;
  end;

  procedure Knoten.setzeVorgaenger(pVorgaenger:Knoten);
  begin
    kenntVorgaenger:=pVorgaenger;
  end;


  destructor Knoten.gibFrei;
  begin
  end;

  constructor Liste.init;
  begin
    hatAnker:=Knoten.init(nil,nil,nil);
    hatAnfang:=hatAnker;
    hatAktuelles:=hatAnker;
  end;

  procedure Liste.fuegeDavorEin(pInhalt:tObject);
   var
    lNeuKnoten:Knoten;
   begin
    if self.istDahinter then
    begin
      lNeuKnoten:=Knoten.init(pInhalt,hatAnker.vorgaenger,hatAnker);
      if self.istLeer then
        hatAnfang:=lNeuKnoten
      else
          hatAnker.vorgaenger.setzeNachfolger(lNeuKnoten);
      hatAnker.setzeVorgaenger(lNeuKnoten);
     end else
           if self.istDavor then begin
             lNeuKnoten:=Knoten.init(pInhalt,nil,hatAnfang);
             hatAnfang.setzeVorgaenger(lNeuKnoten);
             hatAnfang:=lNeuknoten;
           end else begin
                  lNeuKnoten:=Knoten.init(pInhalt,hatAktuelles.vorgaenger,hatAktuelles);
                  if hatAktuelles<>hatAnfang then
                    hatAktuelles.vorgaenger.setzeNachfolger(lNeuKnoten)
                  else hatAnfang:=lNeuKnoten; // Zeile fehlte !!!  
                  hatAktuelles.setzeVorgaenger(lNeuKnoten)
                end;
     inc(zLaenge);
  end;

   procedure Liste.fuegeDahinterEin(pInhalt:tObject);
   var
    lNeuKnoten:Knoten;
   begin
    if self.istDahinter then
    begin
      lNeuKnoten:=Knoten.init(pInhalt,hatAnker.vorgaenger,hatAnker);
      if self.istLeer then
        hatAnfang:=lNeuKnoten
      else
          hatAnker.vorgaenger.setzeNachfolger(lNeuKnoten);
          hatAnker.setzeVorgaenger(lNeuKnoten);
     end else
           if self.istDavor then begin
             lNeuKnoten:=Knoten.init(pInhalt,nil,hatAnfang);
             if self.istLeer then
               hatAnker.setzeVorgaenger(lNeuKnoten)
             else
               hatAnfang.setzeVorgaenger(lNeuKnoten);
               hatAnfang:=lNeuknoten;
           end else begin
                  lNeuKnoten:=Knoten.init(pInhalt,hatAktuelles,hatAktuelles.nachfolger);
                  hatAktuelles.nachfolger.setzeVorgaenger(lNeuKnoten);
                  hatAktuelles.setzeNachfolger(lNeuKnoten);
                end;
     inc(zLaenge);
  end;

  procedure Liste.haengeAn(pInhalt:tObject);
  var lNeuKnoten: Knoten;
  begin
    lNeuKnoten:=Knoten.init(pInhalt,hatAnker.vorgaenger,hatAnker);
    if hatAnker.vorgaenger=nil then
      hatAnfang := lNeuKnoten
    else
      hatAnker.vorgaenger.setzeNachfolger(lNeuKnoten);
    hatAnker.setzeVorgaenger(lNeuKnoten);
    inc(zLaenge);
  end;

  procedure Liste.setzeDavor(pInhalt:tObject);
  var lNeuKnoten: Knoten;
  begin
    lNeuKnoten:=Knoten.init(pInhalt,nil,hatAnfang);
    hatAnfang.setzeVorgaenger(lNeuKnoten);
    hatAnfang:=lNeuKnoten;
    inc(zLaenge);
  end;

  procedure Liste.ersetzeAktuelles(pInhalt:tObject);
  begin
    if not (istDavor or istDahinter) then
      hatAktuelles.setzeInhalt(pInhalt)
  end;

  procedure Liste.entferneAktuelles;
  begin
    if not (istDavor or istDahinter) then begin
      if hatAktuelles=hatAnfang then
        hatAnfang:=hatAnfang.nachfolger
      else // nderung 15.02.06. jd -- vgl. Mail an SuM-Liste
        hatAktuelles.vorgaenger.setzeNachfolger(hatAktuelles.nachfolger);
      hatAktuelles.nachfolger.setzeVorgaenger(hatAktuelles.vorgaenger);
      hatAktuelles:=hatAktuelles.nachfolger;
      dec(zLaenge);
    end
  end;

  procedure Liste.entferneAktuelles(mitInhalt:boolean);
  var
    lZeiger:Knoten;
  begin
    if not (istDavor or istDahinter) then begin
      if hatAktuelles=hatAnfang then
        hatAnfang:=hatAnfang.nachfolger
      else // nderung 15.02.06. jd -- vgl. Mail an SuM-Liste
        hatAktuelles.vorgaenger.setzeNachfolger(hatAktuelles.nachfolger);
      hatAktuelles.nachfolger.setzeVorgaenger(hatAktuelles.vorgaenger);
      lZeiger:=hatAktuelles;
      hatAktuelles:=hatAktuelles.nachfolger;
      if mitInhalt then
        lZeiger.destroy;
      dec(zLaenge);
    end
    // Wo wird eigentlich das Knotenobjekt freigegeben ???
  end;

  procedure Liste.vor;
  begin
    if not istDahinter then
      if istDavor then
        hatAktuelles:=hatAnfang
      else
        hatAktuelles:=hatAktuelles.nachfolger
  end;

  procedure Liste.zurueck;
  begin
    if not istDavor then
      hatAktuelles:=hatAktuelles.vorgaenger
  end;

  procedure Liste.zumAnfang;
  begin
    if self.istLeer then
      hatAktuelles:=hatAnker
    else
      hatAktuelles:=hatAnfang
  end;

  procedure Liste.zumEnde;
  begin
    if self.istLeer then
      hatAktuelles:=nil
    else
      hatAktuelles:=hatAnker.vorgaenger;
  end;

  function Liste.aktuelles:tObject;
  begin
    if self.istDavor or self.istDahinter then
      result:=nil
    else
      result:=hatAktuelles.inhalt;
  end;

  function Liste.istLeer:boolean;
  begin
    result:=zLaenge=0
  end;             

  function Liste.istDavor:boolean;
  begin
    result:=(hatAktuelles=nil);
  end;

  function Liste.istDahinter:boolean;
  begin
    result:=(hatAktuelles=hatAnker);
  end;

  function Liste.istAmAnfang:boolean;
  begin
    result:=not(self.istLeer) and (hatAktuelles.vorgaenger=nil);
  end;

  function Liste.istAmEnde:boolean;
  begin
    result:=not(self.istLeer) and (hatAktuelles.nachfolger=hatAnker);
  end;

  function Liste.laenge:integer;
  begin
    result:=zLaenge;
  end;

procedure Liste.haengeListeAn(pListe:Liste); //Implementation berprfen!
  var lMerkAnker: Knoten;
  begin
    if pListe.laenge>0 then
    begin
      lMerkAnker:=hatAnker;
      if self.laenge > 0 then
      begin
        hatAnker.vorgaenger.setzeNachfolger(pListe.hatAnfang);
        pListe.hatAnfang.setzeVorgaenger(hatAnker.vorgaenger);
      end
      else
      begin
        hatAnfang:=pListe.hatAnfang;
        self.zumAnfang;
      end;
      zLaenge:=zLaenge+pListe.laenge;

      hatAnker:=pListe.hatAnker;
      pListe.hatAnker :=lMerkAnker;
      pListe.hatAnfang    := pListe.hatAnker;
      pListe.hatAktuelles := pListe.hatAnfang;
      pListe.hatAnker.setzeVorgaenger(nil);
      pListe.zLaenge := 0;
    end
  end;


  procedure Liste.setzeListeDavor(pListe:Liste);  //Implementation berprfen!
  begin
    if pListe.laenge>0 then
      if self.laenge > 0 then
      begin
        pListe.hatAnker.vorgaenger.setzeNachfolger(self.hatAnfang);
        self.hatAnfang.setzeVorgaenger(pListe.hatAnfang.vorgaenger);
        hatAnfang:=pListe.hatAnfang;
      end
      else
      begin
        hatAnfang:=pListe.hatAnfang;
        hatAnker:=pListe.hatAnker;
        self.zumAnfang;
      end;
      zLaenge:=zLaenge+pListe.laenge;
  end;

  destructor Liste.gibFrei;
  begin
    self.zumAnfang;
    while not self.istLeer do
      self.entferneAktuelles; // das Inhaltsobjekt wird nicht freigegeben
    hatAnker.destroy;
  end;

  destructor Liste.gibFrei(pMitInhalt: boolean);
  begin
    self.zumAnfang;
    while not self.istLeer do
      self.entferneAktuelles(pMitInhalt);
    hatAnker.destroy;
  end;


end.

