unit mSuMDatenbank;
//
// mDatenbank.pas
//
// Version 1.1 vom 27.07.2003
//
// Klassen fr den Zugriff auf MySQL-Datenbanken unter Delphi (Standard-Versionen)
//
// Entwickelt fr die Lehrerfortbildung Objektorientierte Programmierung
// (LFB OOP) im Regierungsbezirk Arnsberg (NRW) im Auftrag des
// Landesinstitut fr Schule, Soest.
//
// Teile der Arbeit beruhen auf der Freeware TMySQL ...
//
// Rckfragen an Joachim Deckers <joachim.deckers@gmx.de>



interface

uses Windows, Winsock, Classes, Dialogs, StdCtrls, Forms,
     Messages, ExtCtrls, mSuM, mTextwerkzeug, SysUtils;

// Deklaration der DLL-Routinen der MySQL-Client API
// Autor der hier inkludierten Datei mysql.pas: Matthias Fichtner

      // -----------------------------------------------------------------------------------------------
      //
      //                    MySQL Client API for Borland Delphi (version 4 and above)
      //
      //                           Pascal Interface Unit for libmySQL.dll, the
      //                        Client Library for MySQL AB's SQL Database Server
      //
      //                  This is a literal translation of relevant parts of MySQL AB's
      //                    C header files, mysql.h, mysql_com.h, and mysql_version.h
      //
      //                            Copyright (c) 1999-2002 Matthias Fichtner
      //                           (see license.txt for licensing information)
      //
      // -----------------------------------------------------------------------------------------------
      //                       See mysql.h for MySQL AB's copyright and GPL notice
      // -----------------------------------------------------------------------------------------------
      //
      //       17-Aug-1999  mf  Translated mysql.h                             MySQL 3.22.24
      //       19-Aug-1999  mf  Corrected some type definitions                MySQL 3.22.24
      //       20-Aug-1999  mf  Finished debugging the unit                    MySQL 3.22.24
      //       18-Sep-1999  mf  Code maintenance for release 3.22.26a          MySQL 3.22.26a
      //       22-Oct-1999  mf  Code maintenance for release 3.22.28           MySQL 3.22.28
      //       02-Jan-2000  mf  Code maintenance for release 3.22.29           MySQL 3.22.29
      //       21-Jan-2000  mf  Code maintenance for release 3.22.30           MySQL 3.22.30
      //       07-Feb-2000  mf  Code maintenance for release 3.22.31           MySQL 3.22.31
      //       16-Feb-2000  mf  Code maintenance for release 3.22.32           MySQL 3.22.32
      //       13-Aug-2000  mf  Code maintenance for release 3.22.34           MySQL 3.22.34
      //       14-Aug-2000  mf  Reworked entire unit for first 3.23 release    MySQL 3.23.19-beta
      //       14-Aug-2000  mf  Added mysql_character_set_name()               MySQL 3.23.22-beta
      //       11-Sep-2000  mf  Added IS_NUM_FIELD and INTERNAL_NUM_FIELD      MySQL 3.23.24-beta
      //       08-Oct-2000  mf  Modified TMEM_ROOT, enum_server_command,       MySQL 3.23.25-beta
      //                        and INTERNAL_NUM_FIELD
      //       01-Nov-2000  mf  Code maintenance for release 3.23.27           MySQL 3.23.27-beta
      //       25-Nov-2000  mf  Code maintenance for release 3.23.28           MySQL 3.23.28-gamma
      //       05-Jan-2001  mf  Code maintenance for release 3.23.30           MySQL 3.23.30-gamma
      //       19-Jan-2001  mf  Code maintenance for release 3.23.31           MySQL 3.23.31
      //       11-Mar-2001  mf  Added functions mysql_real_send_query(),       MySQL 3.23.33
      //                        mysql_send_query(), and mysql_reap_query()
      //       28-Mai-2001  mf  Modified mysql_send_query(), removed           MySQL 3.23.38
      //                        mysql_real_send_query(), mysql_reap_query(),
      //                        added mysql_read_query_result(), and fixed
      //                        CLIENT_TRANSACTIONS
      //       07-Aug-2001  mf  Code maintenance for release 3.23.40           MySQL 3.23.40
      //       23-Sep-2001  mf  Code maintenance for release 3.23.42           MySQL 3.23.42
      //       29-Jan-2002  mf  Added libmysql_load(), libmysql_free(),        MySQL 3.23.47
      //                        libmysql_status and LIBMYSQL_ constants
      //                        for dynamic loading of libmySQL.dll
      //       11-Mar-2002  mf  Added MYSQL_OPT_LOCAL_INFILE to mysql_option   MySQL 3.23.49
      //
      // -----------------------------------------------------------------------------------------------
      //
      //                   Latest releases of mysql.pas are made available through the
      //                   distribution site at: http://www.fichtner.net/delphi/mysql/
      //
      //                  Please send questions, bug reports, and suggestions regarding
      //                  mysql.pas to Matthias Fichtner <mfichtner@fichtner-meyer.com>
      //
      //                      See readme.txt for an introduction and documentation.
      //                    See license.txt for licensing information and disclaimer.
      //
      // -----------------------------------------------------------------------------------------------
      //                     This unit is provided "as is". Use it at your own risk.
      // -----------------------------------------------------------------------------------------------



      // ----------------
      // From mysql.h ...
      // ----------------

      type
        my_bool = byte;
        gptr = pChar;

      type
        PUSED_MEM = ^TUSED_MEM;  // struct for once_alloc
        TUSED_MEM = record
          next: PUSED_MEM;       // Next block in use
          left: longword;        // memory left in block
          size: longword;        // size of block
        end;

      type
        error_proc = procedure;

      type
        PMEM_ROOT = ^TMEM_ROOT;
        TMEM_ROOT = record
          free: PUSED_MEM;
          used: PUSED_MEM;
          pre_alloc: PUSED_MEM;
          min_malloc: longword;
          block_size: longword;
          error_handler: error_proc;
        end;

      type
        my_socket = TSocket;

      // --------------------
      // From mysql_com.h ...
      // --------------------

      const
        NAME_LEN = 64;               // Field/table name length
        HOSTNAME_LENGTH = 60;
        USERNAME_LENGTH = 16;
        SERVER_VERSION_LENGTH = 60;

        LOCAL_HOST = 'localhost';
        LOCAL_HOST_NAMEDPIPE = '.';

        MYSQL_NAMEDPIPE = 'MySQL';
        MYSQL_SERVICENAME = 'MySql';

      type
        enum_server_command = (
          COM_SLEEP, COM_QUIT, COM_INIT_DB, COM_QUERY,
          COM_FIELD_LIST, COM_CREATE_DB, COM_DROP_DB, COM_REFRESH,
          COM_SHUTDOWN, COM_STATISTICS,
          COM_PROCESS_INFO, COM_CONNECT, COM_PROCESS_KILL,
          COM_DEBUG, COM_PING, COM_TIME, COM_DELAYED_INSERT,
          COM_CHANGE_USER, COM_BINLOG_DUMP,
          COM_TABLE_DUMP, COM_CONNECT_OUT
        );

      const
        NOT_NULL_FLAG = 1;      // Field can't be NULL
        PRI_KEY_FLAG = 2;       // Field is part of a primary key
        UNIQUE_KEY_FLAG = 4;    // Field is part of a unique key
        MULTIPLE_KEY_FLAG = 8;  // Field is part of a key
        BLOB_FLAG = 16;         // Field is a blob
        UNSIGNED_FLAG = 32;     // Field is unsigned
        ZEROFILL_FLAG = 64;     // Field is zerofill
        BINARY_FLAG = 128;

        // The following are only sent to new clients

        ENUM_FLAG = 256;            // field is an enum
        AUTO_INCREMENT_FLAG = 512;  // field is a autoincrement field
        TIMESTAMP_FLAG = 1024;      // Field is a timestamp
        SET_FLAG = 2048;            // field is a set
        NUM_FLAG = 32768;           // Field is num (for clients)
        PART_KEY_FLAG = 16384;      // Intern; Part of some key
        GROUP_FLAG = 32768;         // Intern: Group field
        UNIQUE_FLAG = 65536;        // Intern: Used by sql_yacc

        REFRESH_GRANT = 1;     // Refresh grant tables
        REFRESH_LOG = 2;       // Start on new log file
        REFRESH_TABLES = 4;    // close all tables
        REFRESH_HOSTS = 8;     // Flush host cache
        REFRESH_STATUS = 16;   // Flush status variables
        REFRESH_THREADS = 32;  // Flush status variables
        REFRESH_SLAVE = 64;    // Reset master info and restart slave
                               // thread
        REFRESH_MASTER = 128;  // Remove all bin logs in the index
                               // and truncate the index

        // The following can't be set with mysql_refresh()

        REFRESH_READ_LOCK = 16384;  // Lock tables for read
        REFRESH_FAST = 32768;       // Intern flag

        CLIENT_LONG_PASSWORD = 1;      // new more secure passwords
        CLIENT_FOUND_ROWS = 2;         // Found instead of affected rows
        CLIENT_LONG_FLAG = 4;          // Get all column flags
        CLIENT_CONNECT_WITH_DB = 8;    // One can specify db on connect
        CLIENT_NO_SCHEMA = 16;         // Don't allow database.table.column
        CLIENT_COMPRESS = 32;          // Can use compression protcol
        CLIENT_ODBC = 64;              // Odbc client
        CLIENT_LOCAL_FILES = 128;      // Can use LOAD DATA LOCAL
        CLIENT_IGNORE_SPACE = 256;     // Ignore spaces before '('
        CLIENT_INTERACTIVE = 1024;     // This is an interactive client
        CLIENT_SSL = 2048;             // Switch to SSL after handshake
        CLIENT_IGNORE_SIGPIPE = 4096;  // IGNORE sigpipes
        CLIENT_TRANSACTIONS = 8192;    // Client knows about transactions

        SERVER_STATUS_IN_TRANS = 1;    // Transaction has started
        SERVER_STATUS_AUTOCOMMIT = 2;  // Server in auto_commit mode

        MYSQL_ERRMSG_SIZE = 200;
        NET_READ_TIMEOUT = 30;       // Timeout on read
        NET_WRITE_TIMEOUT = 60;      // Timeout on write
        NET_WAIT_TIMEOUT = 8*60*60;  // Wait for new query

      type
        PVio = ^TVio;
        TVio = record
        end;

      type
        PNET = ^TNET;
        TNET = record
          vio: PVio;
          fd: my_socket;
          fcntl: longint;
          buff, buff_end, write_pos, read_pos: pByte;
          last_error: array [0..MYSQL_ERRMSG_SIZE - 1] of char;
          last_errno, max_packet, timeout, pkt_nr: longword;
          error: byte;
          return_errno, compress: my_bool;
          no_send_ok: my_bool;  // needed if we are doing several
            // queries in one command ( as in LOAD TABLE ... FROM MASTER ),
            // and do not want to confuse the client with OK at the wrong time
          remain_in_buf, length, buf_length, where_b: longword;
          return_status: pLongword;
          reading_or_writing: byte;
          save_char: char;
        end;

      const
        packet_error: longword = $ffffffff;

      const
        FIELD_TYPE_DECIMAL = 0;
        FIELD_TYPE_TINY = 1;
        FIELD_TYPE_SHORT = 2;
        FIELD_TYPE_LONG = 3;
        FIELD_TYPE_FLOAT = 4;
        FIELD_TYPE_DOUBLE = 5;
        FIELD_TYPE_NULL = 6;
        FIELD_TYPE_TIMESTAMP = 7;
        FIELD_TYPE_LONGLONG = 8;
        FIELD_TYPE_INT24 = 9;
        FIELD_TYPE_DATE = 10;
        FIELD_TYPE_TIME = 11;
        FIELD_TYPE_DATETIME = 12;
        FIELD_TYPE_YEAR = 13;
        FIELD_TYPE_NEWDATE = 14;
        FIELD_TYPE_ENUM = 247;
        FIELD_TYPE_SET = 248;
        FIELD_TYPE_TINY_BLOB = 249;
        FIELD_TYPE_MEDIUM_BLOB = 250;
        FIELD_TYPE_LONG_BLOB = 251;
        FIELD_TYPE_BLOB = 252;
        FIELD_TYPE_VAR_STRING = 253;
        FIELD_TYPE_STRING = 254;

      const
        FIELD_TYPE_CHAR = FIELD_TYPE_TINY;      // For compability
        FIELD_TYPE_INTERVAL = FIELD_TYPE_ENUM;  // For compability

      type
        enum_field_types = FIELD_TYPE_DECIMAL..FIELD_TYPE_STRING;

      // ------------------------
      // From mysql_version.h ...
      // ------------------------

      const
        PROTOCOL_VERSION = 10;
        MYSQL_SERVER_VERSION = '3.23.49';
        MYSQL_SERVER_SUFFIX = '';
        FRM_VER = 6;
        MYSQL_VERSION_ID = 32349;
        MYSQL_PORT = 3306;
        MYSQL_UNIX_ADDR = '/tmp/mysql.sock';

      // ----------------
      // From mysql.h ...
      // ----------------

      function IS_PRI_KEY(n: longword): boolean;
      function IS_NOT_NULL(n: longword): boolean;
      function IS_BLOB(n: longword): boolean;
      function IS_NUM(t: longword): boolean;

      type
        PMYSQL_FIELD = ^TMYSQL_FIELD;
        TMYSQL_FIELD = record
          name: pChar;              // Name of column
          table: pChar;             // Table of column if column was a field
          def: pChar;               // Default value (set by mysql_list_fields)
          _type: enum_field_types;  // Type of field. Se mysql_com.h for types
          length: longword;         // Width of column
          max_length: longword;     // Max width of selected set
          flags: longword;          // Div flags
          decimals: longword;       // Number of decimals in field
        end;

      function IS_NUM_FIELD(f: PMYSQL_FIELD): boolean;
      function INTERNAL_NUM_FIELD(f: PMYSQL_FIELD): boolean;

      type
        PMYSQL_ROW = ^TMYSQL_ROW;  // return data as array of strings
        TMYSQL_ROW = array[0..MaxInt div SizeOf(pChar) - 1] of pChar;

      type
        MYSQL_FIELD_OFFSET = longword;  // offset to current field

      type
        my_ulonglong = int64;

      const
        MYSQL_COUNT_ERROR: my_ulonglong = not 0;

      type
        PMYSQL_ROWS = ^TMYSQL_ROWS;
        TMYSQL_ROWS = record
          next: PMYSQL_ROWS;  // list of rows
          data: PMYSQL_ROW;
        end;

      type
        MYSQL_ROW_OFFSET = PMYSQL_ROWS;  // offset to current row

      type
        PMYSQL_DATA = ^TMYSQL_DATA;
        TMYSQL_DATA = record
          rows: my_ulonglong;
          fields: longword;
          data: PMYSQL_ROWS;
          alloc: TMEM_ROOT;
        end;

      type
        PMYSQL_OPTIONS = ^TMYSQL_OPTIONS;
        TMYSQL_OPTIONS = record
          connect_timeout, client_flag: longword;
          compress, named_pipe: my_bool;
          port: longword;
          host, init_command, user, password, unix_socket, db: pChar;
          my_cnf_file, my_cnf_group, charset_dir, charset_name: pChar;
          use_ssl: my_bool;   // if to use SSL or not
          ssl_key: pChar;     // PEM key file
          ssl_cert: pChar;    // PEM cert file
          ssl_ca: pChar;      // PEM CA file
          ssl_capath: pChar;  // PEM directory of CA-s?
        end;

      type
        mysql_option = (
          MYSQL_OPT_CONNECT_TIMEOUT, MYSQL_OPT_COMPRESS,
          MYSQL_OPT_NAMED_PIPE, MYSQL_INIT_COMMAND,
          MYSQL_READ_DEFAULT_FILE, MYSQL_READ_DEFAULT_GROUP,
          MYSQL_SET_CHARSET_DIR, MYSQL_SET_CHARSET_NAME,
          MYSQL_OPT_LOCAL_INFILE
        );

      type
        mysql_status = (
          MYSQL_STATUS_READY, MYSQL_STATUS_GET_RESULT,
          MYSQL_STATUS_USE_RESULT
        );

      type
        PMYSQL_FIELDS = ^TMYSQL_FIELDS;
        TMYSQL_FIELDS = array[0..MaxInt div SizeOf(TMYSQL_FIELD) - 1] of TMYSQL_FIELD;

      type
        PCHARSET_INFO = ^TCHARSET_INFO;
        TCHARSET_INFO = record
          // Omitted: Structure not necessarily needed.
          // Definition of struct charset_info_st can be
          // found in include/m_ctype.h
        end;

      type
        PMYSQL = ^TMYSQL;
        TMYSQL = record
          net: TNET;                    // Communication parameters
          connector_fd: gptr;           // ConnectorFd for SSL
          host, user, passwd, unix_socket, server_version, host_info, info, db: pChar;
          port, client_flag, server_capabilities: longword;
          protocol_version: longword;
          field_count: longword;
          server_status: longword;
          thread_id: longword;          // Id for connection in server
          affected_rows: my_ulonglong;
          insert_id: my_ulonglong;      // id if insert on table with NEXTNR
          extra_info: my_ulonglong;     // Used by mysqlshow
          packet_length: longword;
          status: mysql_status;
          fields: PMYSQL_FIELDS;
          field_alloc: TMEM_ROOT;
          free_me: my_bool;             // If free in mysql_close
          reconnect: my_bool;           // set to 1 if automatic reconnect
          options: TMYSQL_OPTIONS;
          scramble_buff: array [0..8] of char;
          charset: PCHARSET_INFO;
          server_language: longword;
        end;

      type
        PMYSQL_RES = ^TMYSQL_RES;
        TMYSQL_RES = record
          row_count: my_ulonglong;
          field_count, current_field: longword;
          fields: PMYSQL_FIELDS;
          data: PMYSQL_DATA;
          data_cursor: PMYSQL_ROWS;
          field_alloc: TMEM_ROOT;
          row: PMYSQL_ROW;          // If unbuffered read
          current_row: PMYSQL_ROW;  // buffer to current row
          lengths: pLongword;       // column lengths of current row
          handle: PMYSQL;           // for unbuffered reads
          eof: my_bool;             // Used my mysql_fetch_row
        end;

      // Functions to get information from the MYSQL and MYSQL_RES structures
      // Should definitely be used if one uses shared libraries

      var
        mysql_num_rows: function(res: PMYSQL_RES): my_ulonglong; stdcall;
        mysql_num_fields: function(res: PMYSQL_RES): longword; stdcall;
        mysql_eof: function(res: PMYSQL_RES): my_bool; stdcall;
        mysql_fetch_field_direct: function(res: PMYSQL_RES; fieldnr: longword): PMYSQL_FIELD; stdcall;
        mysql_fetch_fields: function(res: PMYSQL_RES): PMYSQL_FIELDS; stdcall;
        mysql_row_tell: function(res: PMYSQL_RES): PMYSQL_ROWS; stdcall;
        mysql_field_tell: function(res: PMYSQL_RES): longword; stdcall;

      var
        mysql_field_count: function(_mysql: PMYSQL): longword; stdcall;
        mysql_affected_rows: function(_mysql: PMYSQL): my_ulonglong; stdcall;
        mysql_insert_id: function(_mysql: PMYSQL): my_ulonglong; stdcall;
        mysql_errno: function(_mysql: PMYSQL): longword; stdcall;
        mysql_error: function(_mysql: PMYSQL): pChar; stdcall;
        mysql_info: function(_mysql: PMYSQL): pChar; stdcall;
        mysql_thread_id: function(_mysql: PMYSQL): longword; stdcall;
        mysql_character_set_name: function(_mysql: PMYSQL): pChar; stdcall;

      type
        PMYSQL_LENGTHS = ^TMYSQL_LENGTHS;
        TMYSQL_LENGTHS = array[0..MaxInt div SizeOf(longword) - 1] of longword;

      type
        extend_buffer_func = function(void: pointer; _to: pChar; length: pLongword): pChar;

      var
        mysql_init: function(_mysql: PMYSQL): PMYSQL; stdcall;
        {$IFDEF HAVE_OPENSSL}
        mysql_ssl_set: function(_mysql: PMYSQL; const key, cert, ca, capath: pChar): longint; stdcall;
        mysql_ssl_cipher: function(_mysql: PMYSQL): pChar; stdcall;
        mysql_ssl_clear: function(_mysql: PMYSQL): longint; stdcall;
        {$ENDIF} // HAVE_OPENSSL
        mysql_connect: function(_mysql: PMYSQL; const host, user, passwd: pChar): PMYSQL; stdcall;
        mysql_change_user: function(_mysql: PMYSQL; const user, passwd, db: pChar): my_bool; stdcall;
        mysql_real_connect: function(_mysql: PMYSQL; const host, user, passwd, db: pChar; port: longword; const unix_socket: pChar; clientflag: longword): PMYSQL; stdcall;
        mysql_close: procedure(sock: PMYSQL); stdcall;
        mysql_select_db: function(_mysql: PMYSQL; const db: pChar): longint; stdcall;
        mysql_query: function(_mysql: PMYSQL; const q: pChar): longint; stdcall;
        mysql_send_query: function(_mysql: PMYSQL; const q: pChar; length: longword): longint; stdcall;
        mysql_read_query_result: function(_mysql: PMYSQL): longint; stdcall;
        mysql_real_query: function(_mysql: PMYSQL; const q: pChar; length: longword): longint; stdcall;
        mysql_create_db: function(_mysql: PMYSQL; const DB: pChar): longint; stdcall;
        mysql_drop_db: function(_mysql: PMYSQL; const DB: pChar): longint; stdcall;
        mysql_shutdown: function(_mysql: PMYSQL): longint; stdcall;
        mysql_dump_debug_info: function(_mysql: PMYSQL): longint; stdcall;
        mysql_refresh: function(_mysql: PMYSQL; refresh_options: longword): longint; stdcall;
        mysql_kill: function(_mysql: PMYSQL; pid: longword): longint; stdcall;
        mysql_ping: function(_mysql: PMYSQL): longint; stdcall;
        mysql_stat: function(_mysql: PMYSQL): pChar; stdcall;
        mysql_get_server_info: function(_mysql: PMYSQL): pChar; stdcall;
        mysql_get_client_info: function: pChar; stdcall;
        mysql_get_host_info: function(_mysql: PMYSQL): pChar; stdcall;
        mysql_get_proto_info: function(_mysql: PMYSQL): longword; stdcall;
        mysql_list_dbs: function(_mysql: PMYSQL; const wild: pChar): PMYSQL_RES; stdcall;
        mysql_list_tables: function(_mysql: PMYSQL; const wild: pChar): PMYSQL_RES; stdcall;
        mysql_list_fields: function(_mysql: PMYSQL; const table, wild: pChar): PMYSQL_RES; stdcall;
        mysql_list_processes: function(_mysql: PMYSQL): PMYSQL_RES; stdcall;
        mysql_store_result: function(_mysql: PMYSQL): PMYSQL_RES; stdcall;
        mysql_use_result: function(_mysql: PMYSQL): PMYSQL_RES; stdcall;
        mysql_options: function(_mysql: PMYSQL; option: mysql_option; const arg: pChar): longint; stdcall;
        mysql_free_result: procedure(result: PMYSQL_RES); stdcall;
        mysql_data_seek: procedure(result: PMYSQL_RES; offset: my_ulonglong); stdcall;
        mysql_row_seek: function(result: PMYSQL_RES; offset: MYSQL_ROW_OFFSET): MYSQL_ROW_OFFSET; stdcall;
        mysql_field_seek: function(result: PMYSQL_RES; offset: MYSQL_FIELD_OFFSET): MYSQL_FIELD_OFFSET; stdcall;
        mysql_fetch_row: function(result: PMYSQL_RES): PMYSQL_ROW; stdcall;
        mysql_fetch_lengths: function(result: PMYSQL_RES): PMYSQL_LENGTHS; stdcall;
        mysql_fetch_field: function(result: PMYSQL_RES): PMYSQL_FIELD; stdcall;
        mysql_escape_string: function(_to: pChar; const from: pChar; from_length: longword): longword; stdcall;
        mysql_real_escape_string: function(_mysql: PMYSQL; _to: pChar; const from: pChar; length: longword): longword; stdcall;
        mysql_debug: procedure(const debug: pChar); stdcall;
        mysql_odbc_escape_string: function(_mysql: PMYSQL; _to: pChar; to_length: longword; const from: pChar; from_length: longword; param: pointer; extend_buffer: extend_buffer_func): pChar; stdcall;
        myodbc_remove_escape: procedure(_mysql: PMYSQL; name: pChar); stdcall;
        mysql_thread_safe: function: longword; stdcall;

      function mysql_reload(_mysql: PMySQL): longint;

      // Status codes for libmySQL.dll

      const
        LIBMYSQL_UNDEFINED = 0;     // libmysql_load() has not yet been called
        LIBMYSQL_MISSING = 1;       // No suitable DLL could be located
        LIBMYSQL_INCOMPATIBLE = 2;  // A DLL was found but it is not compatible
        LIBMYSQL_READY = 3;         // The DLL was loaded successfully

      var
        libmysql_handle: HMODULE = 0;
        libmysql_status: byte = LIBMYSQL_UNDEFINED;

      function libmysql_load(name: pChar): byte;
      procedure libmysql_free;

// Deklarationen der Klassen aus mySQLCommon.pas

      {
        Unit:    TmySQLCommon - Common Data Structures
        Project: TmySQL - http://www.productivity.org/projects/tmysql
        Author:  Justin P. Yunke <yunke@productivity.org>
        Date:    November 1998 - January 2002
        ** Join the TmySQL mailing list at http://www.elists.org **

        Copyrights/Credits:
          Parts Copyright (c) 2001 Justin P. Yunke <yunke@productivity.org>
          Parts Copyright (c) 2001 Ken Kyler
          T.c.X. DataKonsult AB (mySQL software and component bitmap art)
          Bob Silva <bsilva@umesd.k12.or.us> (_libmysql.pas)
          Parts Copyright (c) 2003 Joachim Deckers <deckersj@mariengymnasium-arnsberg.de>

        License:
          Open Source.  You must retain copyrights and distribution information
          listed in these files.

        Description:
          This *.pas file contains some internal code structures for the Tmysql
        project, including TmySQLClientThread, TmySQLClientModify, TmySQLClientQuery,
        and TmySQLClientUtility.

        Date log:

        2003-06-21  Errors in ListResults for list tables (etc.) corrected [deckers]
        2003-07-11  new methods PrepareModifySQL and PrepareModifySQLTask
                    for sending SQL statements directly to the server      [deckers]
      }


      const
        DEFAULT_DLL_LOCATION   = 'libmySQL.DLL';

        DEBUGFILE_COMMON       = 'mysqlcommon.txt';

      {For ChainThreadHandler}
        WM_CHAINTASKHANDLER_COMPLETE = WM_USER + 1;
        WM_CHAINTASKHANDLER_ERROR    = WM_USER + 2;

      {Last Modification Information}
        TMYSQLCOMMON_VERSION       = '2.1x';
        TMYSQLCOMMON_LAST_MODIFIED = '2003-06-21';
        TMYSQLCOMMON_LAST_AUTHOR   = 'jd';

        {TmySQLClientModify constants}
        MAX_SQL_LENGTH       = 65536*2;
        MAX_MEMO_LENGTH      = 32768;

        MAX_LENGTH_HOST      = 255;
        MAX_LENGTH_USER      = 16;
        MAX_LENGTH_PASSWD    = 32;
        MAX_LENGTH_DB        = 64;

        MAX_TASK_NAME_LENGTH = 40;

      type
        TRefreshOptions = (
          _REFRESH_GRANT,
          _REFRESH_LOG,
          _REFRESH_TABLES,
          _REFRESH_HOSTS,
          _REFRESH_STATUS,
          _REFRESH_THREADS,
          _REFRESH_SLAVE,
          _REFRESH_MASTER
        );
        TSetRefreshOptions = set of TRefreshOptions;

      type
        TClientCapabilities = (
          _CLIENT_LONG_PASSWORD,
          _CLIENT_FOUND_ROWS,
          _CLIENT_LONG_FLAG,
          _CLIENT_CONNECT_WITH_DB,
          _CLIENT_NO_SCHEMA,
          _CLIENT_COMPRESS,
          _CLIENT_ODBC,
          _CLIENT_LOCAL_FILES,
          _CLIENT_IGNORE_SPACE,
          _CLIENT_INTERACTIVE,
          _CLIENT_SSL,
          _CLIENT_IGNORE_SIGPIPE,
          _CLIENT_TRANSACTIONS
        );
        TSetClientCapabilities = set of TClientCapabilities;

      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------

      type
        TModifyType = (
          MODIFY_INSERT, MODIFY_UPDATE, MODIFY_REPLACE_INTO, MODIFY_DELETE,
          MODIFY_CREATE_TABLE, MODIFY_DROP_TABLE
        );
        TQuoteOptions = (
          QUOTE_STRIP_CR,QUOTE_STRIP_LF,
          QUOTE_DONT_INSERT_SINGLEQUOTES,
          QUOTE_DONT_USE_NULL
        );
        TQuoteOptionsSet = set of TQuoteOptions;

      type
        TmySQLClientTaskType = (
          task_mysql_connect,
          task_mysql_close,
          task_mysql_real_connect,

          task_mysql_select_db,
          task_mysql_create_db,
          task_mysql_drop_db,

          task_mysql_query,
          task_mysql_store_result,

          task_mysql_list_db,
          task_mysql_list_tables,
          task_mysql_list_fields,
          task_mysql_list_processes,

          task_mysql_ping,
          task_mysql_shutdown,
          task_mysql_kill,
          task_mysql_options,
          task_mysql_refresh
        );

        TmySQLClientQuery_ExecuteType = (Execute_Stored,Execute_Dynamic);

        TmySQLClientThread_OnComplete = procedure(Sender : TObject; Data : TObject) of object;
        TmySQLClientThread_OnError = procedure(Sender : TObject; Data : TObject; Msg : string) of object;

        TmySQLClientTask_OnComplete = procedure(Sender : TObject) of object;
        TmySQLClientTask_OnError = procedure(Sender : TObject; Msg : string) of object;

        TmySQLClientTask_Status = array[0..4] of string;
        TmySQLClientTask_StatusType = (
          mySQL_Status_NotConnected,
          mySQL_Status_Connecting,
          mySQL_Status_Idle,
          mySQL_Status_Active,
          mySQL_Status_Reconnecting
        );
      const
        mySQLClientTask_Status:TmySQLClientTask_Status = ('Not Connected','Connecting','Idle','Active','Reconnecting');

      type
        TmySQLClientTask_OnStatus = procedure(Sender : TObject; Status : TmySQLClientTask_StatusType; TaskName : string; TasksLeft : integer) of object;

        TmySQLClientTaskData = class(TObject)
        public
          FName              : string[MAX_TASK_NAME_LENGTH];

          FTaskType          : TmySQLClientTaskType;
          FPrepared          : boolean;

          F_Wild             : pchar;
          F_ListData         : TStringList;
          F_IntegerData      : integer;

          F_table            : pchar;
          F_modifytype       : TModifyType;
          F_condition        : pchar;

          F_query            : pchar;
          F_host, F_user,
          F_passwd, F_db     : pchar;
          F_port             : Cardinal;
          F_unix_socket      : PChar;
          F_clientflag       : Cardinal;

          F_Session          : pmysql;
          F_presults         : pmysql_res;
          F_ret_code         : integer;
          F_pid              : integer;
          F_options          : mysql_option;
          F_refresh_options  : cardinal;
          F_arg              : pchar;

          F_keyfield         : longword;
          F_executetype      : TmySQLClientQuery_ExecuteType;

          FThreadOnComplete  : TmySQLClientThread_OnComplete;
          FThreadOnError     : TmySQLClientThread_OnError;

          FTaskOnComplete    : TmySQLClientTask_OnComplete;
          FTaskOnError       : TmySQLClientTask_OnError;

          constructor Create;
          destructor  Destroy; override;
        end;

        TmySQLClientThread = class(TThread)
        private
          FHandlerWndHandle : HWND;

          FSession : pmysql;

          FTaskList : TList;

          FThreaded : boolean;

          FOnStatus : TmySQLClientTask_OnStatus;
          FOnFinished : TmySQLClientTask_OnComplete;

          procedure   Run(T : TmySQLClientTaskData);
          procedure   Finish(T : TmySQLClientTaskData);

          procedure   PostComplete(T : TmySQLClientTaskData);
          procedure   PostError(T : TmySQLClientTaskData);

          procedure   ResumeNonThread;

          function    GetTaskCount : integer;
        public
          constructor Create(CreateSuspended : boolean);
          destructor  Destroy; override;

          property    Session : pmysql read FSession write FSession;

          property    TaskCount : integer read GetTaskCount;

          property    OnStatus : TmySQLClientTask_OnStatus read FOnStatus write FOnStatus;
          property    OnFinished : TmySQLClientTask_OnComplete read FOnFinished write FOnFinished;

          procedure   Prepare_mysql_real_connect(
            const host, user, passwd, db: pchar;
            port: Cardinal; unix_socket: PChar; clientflag: Cardinal;

            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_close(
            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_db(
            tasktype : TmySQLClientTaskType;

            db : pchar;
            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_query(
            tasktype : TmySQLClientTaskType;

            _query : pchar;

            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_list(
            const TaskType : TmySQLClientTaskType;

            Wild : pchar;

            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_list_fields(
            TableName : pchar;
            Wild : pchar;

            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_list_processes(
            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_ping_shutdown(
            const TaskType : TmySQLClientTaskType;
            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_kill(
            const pid : integer;
            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_options(
            const opt: mysql_option; arg: pchar;
            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Prepare_mysql_refresh(
            const RefreshOptions: cardinal;
            const TaskName : string;

            OnComplete     : TmySQLClientThread_OnComplete;
            OnError        : TmySQLClientThread_OnError;

            OnTaskComplete : TmySQLClientTask_OnComplete;
            OnTaskError    : TmySQLClientTask_OnError
          );

          procedure   Execute; override;
        end;

        TmySQLClientTaskHandler = class(TObject)
        private
          FWndHandle         : HWND;

          FThreaded          : boolean;
          FThread            : TmySQLClientThread;

          function    GetSession : pmysql;
          procedure   SetSession(Session : pmysql);

          function    GetThreaded : boolean;
          procedure   SetThreaded(B : boolean);
        protected
          procedure   WndProc(var Mesg : TMessage); virtual;
        public
          constructor Create(const BThreaded : boolean); virtual;
          destructor  Destroy; override;

          property    Session : pmysql read GetSession write SetSession;

          property    Threaded : boolean read GetThreaded write SetThreaded;
          property    Thread : TmySQLClientThread read FThread write FThread;

          procedure   StartTasks;

          procedure   DumpTasks;
        end;

      type
        TmySQLClientModifyData = class(TObject)
        private
          pData : pchar;
        public
          property Data : pchar read pData write pData;
          destructor Destroy; override;
        end;

        TmySQLClientModify = class(TObject)
        private
          FTaskHandler        : TmySQLClientTaskHandler;

          FData               : TStringList;

          FCurrentTaskData    : TmySQLClientTaskData;

          FDefault_OnComplete : TmySQLClientTask_OnComplete;
          FDefault_OnError    : TmySQLClientTask_OnError;

          procedure   Combine(T : TmySQLClientTaskData);

          procedure   _OnComplete(Sender: TObject; Data: TObject);
          procedure   _OnError(Sender: TObject; Data: TObject; Msg: string);
        protected
        public
          constructor Create;
          destructor  Destroy; override;

          property    TaskHandler : TmySQLClientTaskHandler read FTaskHandler write FTaskHandler;

          property    CurrentTaskData : TmySQLClientTaskData read FCurrentTaskData write FCurrentTaskData;

          property    Default_OnComplete : TmySQLClientTask_OnComplete read FDefault_OnComplete write FDefault_OnComplete;
          property    Default_OnError    : TmySQLClientTask_OnError    read FDefault_OnError    write FDefault_OnError;

          procedure   Add(const Column : string; Data : pchar);
          procedure   AddString(const Column : string; const Data : string);
          procedure   AddInteger(const Column : string; const Data : integer);
          procedure   AddMemo(const Column : string; Memo : TMemo);

          procedure   PrepareCreateTable(Table : pchar; const TaskName : string);
          procedure   PrepareCreateTableTask(
            Table : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareDropTable(Table : pchar; const TaskName : string);
          procedure   PrepareDropTableTask(
            Table : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareInsert(Table : pchar; const TaskName : string);
          procedure   PrepareInsertTask(
            Table : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareUpdate(Table : pchar; Condition : pchar; const TaskName : string);
          procedure   PrepareUpdateTask(
            Table, Condition : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareUpdateString(Table : pchar; const Condition : string; const TaskName : string);
          procedure   PrepareUpdateStringTask(
            Table : pchar; const Condition : string;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareReplaceInto(Table : pchar; Condition : pchar; const TaskName : string);
          procedure   PrepareReplaceIntoTask(
            Table, Condition : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareReplaceIntoString(Table : pchar; const Condition : string; const TaskName : string);
          procedure   PrepareReplaceIntoStringTask(
            Table : pchar; const Condition : string;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareDelete(Table, Condition : pchar; const TaskName : string);
          procedure   PrepareDeleteTask(
            Table, Condition : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareDeleteString(Table : pchar; const Condition : string; const TaskName : string);
          procedure   PrepareDeleteStringTask(
            Table : pchar; const Condition : string;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareModifySQL(pSQL: string;pTaskname: string);
          procedure   PrepareModifySQLTask(
            pSQL: string;
            pTaskname: string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   Reset;
        end;

      type
        TmySQLClientQuery = class(TObject)
        private
          FTaskHandler : TmySQLClientTaskHandler;

          FData         : TStringList;
          FFields       : TStringList;
          FFieldsLoaded : boolean;

          FCurrentTaskData : TmySQLClientTaskData;

          FDefault_OnComplete : TmySQLClientTask_OnComplete;
          FDefault_OnError    : TmySQLClientTask_OnError;

          procedure   GetFields;
          function    GetFieldCount : integer;
          function    GetField(const i : longint) : pmysql_field;
          function    GetFieldName(const i : longint) : string;
          function    GetIndexByFieldName(const FieldString : string) : integer;

          function    GetDataCount : integer;

          procedure   _OnComplete(Sender: TObject; Data: TObject);
          procedure   _OnError(Sender: TObject; Data: TObject; Msg: string);
        public
          constructor Create;
          destructor  Destroy; override;

          property    Default_OnComplete : TmySQLClientTask_OnComplete read FDefault_OnComplete write FDefault_OnComplete;
          property    Default_OnError    : TmySQLClientTask_OnError    read FDefault_OnError    write FDefault_OnError;

          property    FieldCount : integer read GetFieldCount;
          property    Field[const i : integer] : pmysql_field read GetField;
          property    FieldName[const i : integer] : string read GetFieldName;

          property    DataCount : integer read GetDataCount;

          property    TaskHandler : TmySQLClientTaskHandler read FTaskHandler write FTaskHandler;

          property    CurrentTaskData : TmySQLClientTaskData read FCurrentTaskData write FCurrentTaskData;

          function    Data(const i, j : longword) : pchar;
          function    DataAsInteger(const i, j : longword) : integer;
          function    DataAsDateTime(const i, j : longword) : TDateTime;

          function    DataByFieldName(const i : longint; const FieldString : string) : pchar;

          procedure   Prepare(Query : pchar; const TaskName : string);
          procedure   PrepareTask(
            Query : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   Reset;
        end;

      type
        TmySQLClientUtility = class(TObject)
        private
          FTaskHandler   : TmySQLClientTaskHandler;

          FCurrentTaskData : TmySQLClientTaskData;

          function    GetServerInfo : string;
          function    GetClientInfo : string;
          function    GetHostInfo   : string;
          function    GetProtoInfo  : byte;

          function    GetErrorMsg : string;
          function    GetStat     : pchar;

          function    GetListResult : TStringList;
          function    GetIntegerResult : integer;

          procedure   _OnComplete(Sender: TObject; Data: TObject);
          procedure   _OnError(Sender: TObject; Data: TObject; Msg: string);
        protected
        public
          Default_OnSelectDatabase         : TmySQLClientTask_OnComplete;
          Default_OnSelectDatabaseError    : TmySQLClientTask_OnError;

          Default_OnCreateDatabase         : TmySQLClientTask_OnComplete;
          Default_OnCreateDatabaseError    : TmySQLClientTask_OnError;

          Default_OnDropDatabase           : TmySQLClientTask_OnComplete;
          Default_OnDropDatabaseError      : TmySQLClientTask_OnError;

          Default_OnListDatabases          : TmySQLClientTask_OnComplete;
          Default_OnListDatabasesError     : TmySQLClientTask_OnError;

          Default_OnListTables             : TmySQLClientTask_OnComplete;
          Default_OnListTablesError        : TmySQLClientTask_OnError;

          Default_OnListFields             : TmySQLClientTask_OnComplete;
          Default_OnListFieldsError        : TmySQLClientTask_OnError;

          Default_OnListProcesses          : TmySQLClientTask_OnComplete;
          Default_OnListProcessesError     : TmySQLClientTask_OnError;

          Default_OnPing                   : TmySQLClientTask_OnComplete;
          Default_OnPingError              : TmySQLClientTask_OnError;

          Default_OnShutdown               : TmySQLClientTask_OnComplete;
          Default_OnShutdownError          : TmySQLClientTask_OnError;

          Default_OnKill                   : TmySQLClientTask_OnComplete;
          Default_OnKillError              : TmySQLClientTask_OnError;

          Default_OnOptions                : TmySQLClientTask_OnComplete;
          Default_OnOptionsError           : TmySQLClientTask_OnError;

          Default_OnRefresh                : TmySQLClientTask_OnComplete;
          Default_OnRefreshError           : TmySQLClientTask_OnError;

          constructor Create;
          destructor  Destroy; override;

          property    TaskHandler : TmySQLClientTaskHandler read FTaskHandler write FTaskHandler;
          property    CurrentTaskData : TmySQLClientTaskData read FCurrentTaskData write FCurrentTaskData;

          property    ServerInfo : string read GetServerInfo;
          property    ClientInfo : string read GetClientInfo;
          property    HostInfo   : string read GetHostInfo;
          property    ProtoInfo  : byte   read GetProtoInfo;

          property    ErrorMsg   : string read GetErrorMsg;
          property    Stat       : pchar read GetStat;

          property    ListResult : TStringList read GetListResult;
          property    PingResult : integer read GetIntegerResult;
          property    RefreshResult : integer read GetIntegerResult;
          property    OptionsResult : integer read GetIntegerResult;
          property    ShutdownResult : integer read GetIntegerResult;

          procedure   PrepareConnectTask(
            const host, user, passwd, db: pchar;
            port: Cardinal; unix_socket: PChar; clientflag: Cardinal;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareCloseTask(
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareSelectDatabase(
            db : pchar;
            const TaskName : string
          );
          procedure   PrepareSelectDatabaseTask(
            db : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareCreateDatabase(
            db : pchar;
            const TaskName : string
          );
          procedure   PrepareCreateDatabaseTask(
            db : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareDropDatabase(
            db : pchar;
            const TaskName : string
          );
          procedure   PrepareDropDatabaseTask(
            db : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareListDatabases(
            Wild : pchar;
            const TaskName : string
          );
          procedure   PrepareListDatabasesTask(
            Wild : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareListTables(
            Wild : pchar;
            const TaskName : string
          );
          procedure   PrepareListTablesTask(
            Wild : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareListFields(
            TableName : pchar;
            Wild : pchar;
            const TaskName : string
          );
          procedure   PrepareListFieldsTask(
            TableName : pchar;
            Wild : pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure   PrepareListProcesses(
            const TaskName : string
          );
          procedure   PrepareListProcessesTask(
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure PreparePing(
            const TaskName : string
          );
          procedure PreparePingTask(
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure PrepareShutdown(
            const TaskName : string
          );
          procedure PrepareShutdownTask(
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure PrepareKill(
            const pid : integer;
            const TaskName : string
          );
          procedure PrepareKillTask(
            const pid : integer;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure PrepareOptions(
            const opt: mysql_option; arg: pchar;
            const TaskName : string
          );
          procedure PrepareOptionsTask(
            const opt: mysql_option; arg: pchar;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

          procedure PrepareRefresh(
            const RefreshOptions: TSetRefreshOptions;
            const TaskName : string
          );
          procedure PrepareRefreshTask(
            const RefreshOptions: TSetRefreshOptions;
            const TaskName : string;
            OnComplete : TmySQLClientTask_OnComplete;
            OnError    : TmySQLClientTask_OnError
          );

        end;

        function Quote(pout, pin : pchar; var len : integer; const Options : TQuoteOptionsSet) : pchar;
        function QuoteString(sIn : string; const Options : TQuoteOptionsSet) : string;
      //  function EscapeString(const S : string) : string; - Broken in DLL?

      var
        libmysql_location : string;


// Klassen fr SQL-Clients

      {
        Unit:    TmySQLClient - Common Data Structures
        Project: TmySQL - http://www.productivity.org/projects/tmysql
        Author:  Justin P. Yunke <yunke@productivity.org>
        Date:    November 1998 - January 2002
        ** Join the TmySQL mailing list at http://www.elists.org **

        Copyrights/Credits:
          Parts Copyright (c) 2001 Justin P. Yunke <yunke@productivity.org>
          Parts Copyright (c) 2001 Ken Kyler
          MySQL AB (mySQL software and component bitmap art)
          Bob Silva <bsilva@umesd.k12.or.us> (_libmysql.pas)
          Parts Copyright (c) 2003 Joachim Deckers <deckersj@mariengymnasium-arnsberg.de>

        License:
          Open Source.  You must retain copyrights and distribution information
          listed in these files.

        Description:
          This Delphi VCL/Custom Component set allows TCP/IP-based connections
        to mySQL servers, and support code to allow full use of the libmysql.DLL
        library provided by TcX for mysql.
          Programmers can either use mySQLClient VCL directly, or indirectly
        by using the TmySQLDB VCLs (see mySQLDB.pas).

        Requirements:
          Delphi 3.0 (I believe)
          libmysql.dll dated 1/5/99 or later

        Date Log:

        8/9/2001: Tons of undocumented changes over many months.

        1/6/99: Refreshed log.  Switched some things around to fit a model
        suggested by Ken.  Once we get good documentation up, it'll start to
        make sense.  Today marked an important day due to Monty's fix for the
        libmysql DLL, making it thread safe.  I plan to add many nice Threaded
        goodies/options over the next few weeks.  jy

        1/14/99a: A week later, I have some working Threaded code.  A restructuring
        occurred on how one uses TmySQLClientQuery and TmySQLClientModify.

        1/27/99a: Cleaned up, reviewed code.

        2/14/99a: Major revisions completed over the past two weeks, including the
        implementation of a queuing system for SQL queries/modifications.

        2/16/99a: Generation of TmySQLClientUtility class.  Began work on making
        all utility functions (connect, close, ping, etc.) threaded.  Extensive
        reworking of TmySQLClient VCL events.

        2/16/99b: All utility functions have been moved into the TmySQLClientUtility
        class.  Next step is to build the test app so that it tests everything.

        2/17/99a: Test app built and is running fine.  Complete some minor changes
        and improvements to various functions in mySQLCommon.

        2/22/99a: Minor changes to Refresh and Options capabilities.

        3/8/99: Quick one-line bug fix for queries.

        3/16/99: Spent time bug hunting.

        1/5/00: Major bugfixes and addition of connection timeout.

        7/23/01: Massive memory leak found and removed.

      }


      const
      {Last Modification Information}
        TMYSQLCLIENT_VERSION       = '2.1x';
        TMYSQLCLIENT_LAST_MODIFIED = '2003-06-21';
        TMYSQLCLIENT_LAST_AUTHOR   = 'deckers';

        DEFAULT_CONNECTED_TIMEOUT_INTERVAL = 300000; // 5 minutes

      { The TCustom_mySQLClient component is for deriving your own custom components. }
      { Most people will probably use TmySQLClient through the VCL palette.         jy}
      type
        TCustom_mySQLClient = class(TComponent)
        private
          FThreaded                 : boolean;

          FSession                  : tmysql;

          FCap                      : integer;

          FTaskHandler              : TmySQLClientTaskHandler;

          FQuery                    : TmySQLClientQuery;
          FModify                   : TmySQLClientModify;
          FUtility                  : TmySQLClientUtility;

          FConnected                : boolean;

          FConnectedTimeoutInterval : integer;
          FConnectedTimer           : TTimer;
          FTimedOut                 : boolean;

          FBlockOnClose             : boolean;

          FDLLPath,
          FHost,
          FUser,
          FPasswd,
          FDb                       : string;
          FPort                     : integer;
          FCapabilities             : TSetClientCapabilities;

          FOnConnect                : TmySQLClientTask_OnComplete;
          FOnConnectError           : TmySQLClientTask_OnError;

          FOnClose                  : TmySQLClientTask_OnComplete;

          FOnQuery                  : TmySQLClientTask_OnComplete;
          FOnQueryError             : TmySQLClientTask_OnError;

          FOnModify                 : TmySQLClientTask_OnComplete;
          FOnModifyError            : TmySQLClientTask_OnError;

          FOnSelectDatabase         : TmySQLClientTask_OnComplete;
          FOnSelectDatabaseError    : TmySQLClientTask_OnError;

          FOnCreateDatabase         : TmySQLClientTask_OnComplete;
          FOnCreateDatabaseError    : TmySQLClientTask_OnError;

          FOnDropDatabase           : TmySQLClientTask_OnComplete;
          FOnDropDatabaseError      : TmySQLClientTask_OnError;

          FOnListDatabases          : TmySQLClientTask_OnComplete;
          FOnListDatabasesError     : TmySQLClientTask_OnError;

          FOnListTables             : TmySQLClientTask_OnComplete;
          FOnListTablesError        : TmySQLClientTask_OnError;

          FOnListFields             : TmySQLClientTask_OnComplete;
          FOnListFieldsError        : TmySQLClientTask_OnError;

          FOnListProcesses          : TmySQLClientTask_OnComplete;
          FOnListProcessesError     : TmySQLClientTask_OnError;

          FOnPing                   : TmySQLClientTask_OnComplete;
          FOnPingError              : TmySQLClientTask_OnError;

          FOnShutdown               : TmySQLClientTask_OnComplete;
          FOnShutdownError          : TmySQLClientTask_OnError;

          FOnKill                   : TmySQLClientTask_OnComplete;
          FOnKillError              : TmySQLClientTask_OnError;

          FOnOptions                : TmySQLClientTask_OnComplete;
          FOnOptionsError           : TmySQLClientTask_OnError;

          FOnRefresh                : TmySQLClientTask_OnComplete;
          FOnRefreshError           : TmySQLClientTask_OnError;

          FOnStatus                 : TmySQLClientTask_OnStatus;

          procedure   SetDLLPath(const S : string);
          function    GetDLLPath : string;

          procedure   SetHostname(const S : string);
          function    GetHostname : string;
          procedure   SetPort(const i : integer);
          function    GetPort : integer;

          procedure   SetUsername(const S : string);
          function    GetUsername : string;
          procedure   SetPassword(const S : string);
          function    GetPassword : string;

          procedure   SetDatabase(const S : string);
          function    GetDatabase : string;

          procedure   SetCapabilities (const C : TSetClientCapabilities);
          function    GetCapabilities : TSetClientCapabilities;

          procedure   SetOnStatus(OS : TmySQLClientTask_OnStatus);
          function    GetOnStatus : TmySQLClientTask_OnStatus;

          function    GetThreaded : boolean;
          procedure   SetThreaded(const b : boolean);

          procedure   _OnConnect(Sender : TObject);
          procedure   _OnClose(Sender : TObject);
          procedure   _OnTimeOut(Sender : TObject);
          procedure   _OnTaskFinished(Sender : TObject);

          procedure   StartTimer;
          procedure   StopTimer;

          function    CreateQuery : TmySQLClientQuery;
          function    CreateModify : TmySQLClientModify;
        protected
          property    Connected             : boolean read FConnected;

          property    BlockOnClose          : boolean read FBlockOnClose write FBlockOnClose;

          property    Threaded              : boolean read GetThreaded  write SetThreaded;

          property    DLLPath               : string read GetDLLPath write SetDLLPath;

          property    Hostname              : string read GetHostname write SetHostname;
          property    Port                  : integer read GetPort write SetPort;

          property    Username              : string read GetUsername write SetUsername;
          property    Password              : string read GetPassword write SetPassword;

          property    Database              : string read GetDatabase write SetDatabase;

          property    ConnectedTimer        : TTimer read FConnectedTimer write FConnectedTimer;
          property    ConnectedTimeOutInterval : integer read FConnectedTimeOutInterval write FConnectedTimeOutInterval;

          property    Capabilities          : TSetClientCapabilities read GetCapabilities write SetCapabilities;

          property    OnConnect             : TmySQLClientTask_OnComplete read FOnConnect      write FOnConnect;
          property    OnConnectError        : TmySQLClientTask_OnError    read FOnConnectError write FOnConnectError;

          property    OnClose               : TmySQLClientTask_OnComplete read FOnClose write FOnClose;

          property    OnQuery               : TmySQLClientTask_OnComplete read FOnQuery         write FOnQuery;
          property    OnQueryError          : TmySQLClientTask_OnError    read FOnQueryError    write FOnQueryError;

          property    OnModify              : TmySQLClientTask_OnComplete read FOnModify write FOnModify;
          property    OnModifyError         : TmySQLClientTask_OnError    read FOnModifyError    write FOnModifyError;

          property    OnSelectDatabase      : TmySQLClientTask_OnComplete read FOnSelectDatabase write FOnSelectDatabase;
          property    OnSelectDatabaseError : TmySQLClientTask_OnError    read FOnSelectDatabaseError write FOnSelectDatabaseError;

          property    OnCreateDatabase      : TmySQLClientTask_OnComplete read FOnCreateDatabase write FOnCreateDatabase;
          property    OnCreateDatabaseError : TmySQLClientTask_OnError    read FOnCreateDatabaseError write FOnCreateDatabaseError;

          property    OnDropDatabase        : TmySQLClientTask_OnComplete read FOnDropDatabase write FOnDropDatabase;
          property    OnDropDatabaseError   : TmySQLClientTask_OnError    read FOnDropDatabaseError write FOnDropDatabaseError;

          property    OnListDatabases       : TmySQLClientTask_OnComplete read FOnListDatabases write FOnListDatabases;
          property    OnListDatabasesError  : TmySQLClientTask_OnError    read FOnListDatabasesError write FOnListDatabasesError;

          property    OnListTables          : TmySQLClientTask_OnComplete read FOnListTables write FOnListTables;
          property    OnListTablesError     : TmySQLClientTask_OnError    read FOnListTablesError write FOnListTablesError;

          property    OnListFields          : TmySQLClientTask_OnComplete read FOnListFields write FOnListFields;
          property    OnListFieldsError     : TmySQLClientTask_OnError    read FOnListFieldsError write FOnListFieldsError;

          property    OnListProcesses       : TmySQLClientTask_OnComplete read FOnListProcesses write FOnListProcesses;
          property    OnListProcessesError  : TmySQLClientTask_OnError    read FOnListProcessesError write FOnListProcessesError;

          property    OnPing                : TmySQLClientTask_OnComplete read FOnPing write FOnPing;
          property    OnPingError           : TmySQLClientTask_OnError    read FOnPingError write FOnPingError;

          property    OnOptions             : TmySQLClientTask_OnComplete read FOnOptions write FOnOptions;
          property    OnOptionsError        : TmySQLClientTask_OnError    read FOnOptionsError write FOnOptionsError;

          property    OnRefresh             : TmySQLClientTask_OnComplete read FOnRefresh write FOnRefresh;
          property    OnRefreshError        : TmySQLClientTask_OnError    read FOnRefreshError write FOnRefreshError;

          property    OnShutdown            : TmySQLClientTask_OnComplete read FOnShutdown write FOnShutdown;
          property    OnShutdownError       : TmySQLClientTask_OnError    read FOnShutdownError write FOnShutdownError;

          property    OnStatus              : TmySQLClientTask_OnStatus  read GetOnStatus write SetOnStatus;
        public
          property    Query   : TmySQLClientQuery   read FQuery   write FQuery;
          property    Modify  : TmySQLClientModify  read FModify  write FModify;
          property    Utility : TmySQLClientUtility read FUtility write FUtility;

          property    TaskHandler : TmySQLClientTaskHandler read FTaskHandler write FTaskHandler;

          constructor Create(AOwner : TComponent); override;
          destructor  Destroy; override;

          procedure   Connect; overload;
          procedure   Connect(pHost: String); overload;
          procedure   Connect(pHost: String; pPort: integer); overload;

          procedure   Close;
          procedure   ForceClose;

          procedure   Execute;
        end;

      { This CLASS is the visual component you will most likely }
      { use.                                                  jy}
        TmySQLClient = class(TCustom_mySQLClient)
        public
          property    Connected;
        published
          property    DLLPath;

          property    Hostname;
          property    Port;

          property    Username;
          property    Password;

          property    Database;

          property    Capabilities;

          property    Threaded;

          property    ConnectedTimeOutInterval;
          property    ConnectedTimer;

          property    BlockOnClose;

          property    OnConnect;
          property    OnConnectError;

          property    OnClose;

          property    OnQuery;
          property    OnQueryError;

          property    OnModify;
          property    OnModifyError;

          property    OnSelectDatabase;
          property    OnSelectDatabaseError;

          property    OnCreateDatabase;
          property    OnCreateDatabaseError;

          property    OnDropDatabase;
          property    OnDropDatabaseError;

          property    OnListDatabases;
          property    OnListDatabasesError;

          property    OnListTables;
          property    OnListTablesError;

          property    OnListFields;
          property    OnListFieldsError;

          property    OnListProcesses;
          property    OnListProcessesError;

          property    OnPing;
          property    OnPingError;

          property    OnRefresh;
          property    OnRefreshError;

          property    OnOptions;
          property    OnOptionsError;

          property    OnShutdown;
          property    OnShutdownError;

          property    OnStatus;
        end;


// Spezifische Klassen der LFB OOP gem Klassendokumentation auf dem
// NRW-Bildungsserver unter http://www.learnline.de/angebote/oop/

const TRANSACTION_NONE = 0;
      TRANSACTION_READ_COMMITTED = 1;
      TRANSACTION_READ_UNCOMMITTED = 2;
      TRANSACTION_REPEATABLE_READ = 3;
      TRANSACTION_SERIALIZABLE = 4;
type SQLErgebnisliste = class
       private
         kenntDatenbank: TCustom_mySQLClient;
         prErfolgreich : Wahrheitswert; // war die Abfrage erfolgreich?
         prAktuelleZeile: GanzeZahl;
       public
         constructor init (pDatenbank : TCustom_mySQLClient);
         procedure   vor;
         procedure   zumAnfang;
         procedure   setzeGueltig;
         procedure   setzeUngueltig;
         function    zeilenAnzahl : GanzeZahl;
         function    spaltenAnzahl : GanzeZahl;
         function    aktuelleZeile : GanzeZahl;
         function    spaltentyp(pSpalte:GanzeZahl) : Zeichenkette;
         function    spaltenname(pSpalte:GanzeZahl) : Zeichenkette;
         function    spaltenbreite(pSpalte: GanzeZahl): GanzeZahl;
         function    istDahinter : Wahrheitswert;
         function    datenfeldAlsText(pDatenfeldname : Zeichenkette) : Zeichenkette; overload;
         function    datenfeldAlsZahl(pDatenfeldname : Zeichenkette) : Zahl; overload;
         function    datenfeldAlsGanzeZahl(pDatenfeldname : Zeichenkette) : GanzeZahl; overload;
         function    datenfeldAlsText(pIndex : GanzeZahl) : Zeichenkette; overload;
         function    datenfeldAlsZahl(pIndex : GanzeZahl) : Zahl; overload;
         function    datenfeldAlsGanzeZahl(pIndex : GanzeZahl) : GanzeZahl; overload;
         function    alsTabelle: Zeichenkette;
         destructor  gibFrei;
     end;


type Komponente = TComponent;

type Datenbank = class (TCustom_mySQLClient)
     private
       hatTextwerkzeug: Textwerkzeug;
       hatSQLErgebnis : SQLErgebnisliste;
       zFehler,
       zAusgefuehrt,
       zVerbindungAufgebaut: Wahrheitswert;
       zFehlermeldung: Zeichenkette;
       zAktuelleZeile: GanzeZahl;

     protected
       // Anzeige von (Fehler-)Meldungen
       procedure   dbfehler(sender: TObject; nachricht: string);
       procedure   dbverbunden(sender: TObject);
       procedure   SQLFehler(sender: TObject; nachricht: string);
       procedure   SQLAusgefuehrt(sender: TObject);
       procedure   fehler(nachricht: string);

       procedure   setzeTransaktionsStatus(pStatus : GanzeZahl);
       procedure   setzeAenderungsStatus(pStatus : Wahrheitswert);
       procedure   aenderungenAufnehmen;
     public
       constructor init(eigentuemer: komponente);
       function    verbinde(pDatenbank, pTreiber, pAnbindung, pUser, pPasswort : Zeichenkette): Zeichenkette;
       function    verbindeMySQL(pDatenbank, pServer, pUser, pPasswort : Zeichenkette): Zeichenkette; overload;
       function    verbindeMySQL(pDatenbank, pServer: Zeichenkette; pPort: GanzeZahl; pUser, pPasswort : Zeichenkette): Zeichenkette; overload;
       procedure   trenne;
       function    datenbankinfo: Zeichenkette;
       function    tabellenAnzahl: GanzeZahl;
       function    tabellenName(pNummer :GanzeZahl) : Zeichenkette;
       procedure   datenbankAendern(pSQL : Zeichenkette);
       function    ergebnis : SQLErgebnisliste;
       function    sendeSQL(pSQL : Zeichenkette): Zeichenkette;
       function    istVerbunden: Wahrheitswert;
       destructor  gibFrei;
     end;


// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------

implementation

// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------


// Definition der Routinen der MySQL-Client API

      function IS_PRI_KEY(n: longword): boolean;
      begin
        Result := (n and PRI_KEY_FLAG) = PRI_KEY_FLAG;
      end;

      function IS_NOT_NULL(n: longword): boolean;
      begin
        Result := (n and NOT_NULL_FLAG) = NOT_NULL_FLAG;
      end;

      function IS_BLOB(n: longword): boolean;
      begin
        Result := (n and BLOB_FLAG) = BLOB_FLAG;
      end;

      function IS_NUM(t: longword): boolean;
      begin
        Result := (t <= FIELD_TYPE_INT24) or (t = FIELD_TYPE_YEAR);
      end;

      function IS_NUM_FIELD(f: PMYSQL_FIELD): boolean;
      begin
        Result := (f.flags and NUM_FLAG) = NUM_FLAG;
      end;

      function INTERNAL_NUM_FIELD(f: PMYSQL_FIELD): boolean;
      begin
        Result := (((f._type <= FIELD_TYPE_INT24) and ((f._type <> FIELD_TYPE_TIMESTAMP) or (f.length = 14) or (f.length = 8))) or (f._type = FIELD_TYPE_YEAR));
      end;

      function mysql_reload(_mysql: PMYSQL): longint;
      begin
        Result := mysql_refresh(_mysql, REFRESH_GRANT);
      end;

      function libmysql_load(name: pChar): byte;

        procedure assign_proc(var proc: FARPROC; name: pChar);
        begin
          proc := GetProcAddress(libmysql_handle, name);
          if proc = nil then libmysql_status := LIBMYSQL_INCOMPATIBLE;
        end;

      begin
        libmysql_free;
        if name = nil then name := 'libmysql.dll';
        libmysql_handle := LoadLibrary(name);
        if libmysql_handle = 0 then libmysql_status := LIBMYSQL_MISSING
        else begin
          libmysql_status := LIBMYSQL_READY;
          assign_proc(@mysql_num_rows, 'mysql_num_rows');
          assign_proc(@mysql_num_fields, 'mysql_num_fields');
          assign_proc(@mysql_eof, 'mysql_eof');
          assign_proc(@mysql_fetch_field_direct, 'mysql_fetch_field_direct');
          assign_proc(@mysql_fetch_fields, 'mysql_fetch_fields');
          assign_proc(@mysql_row_tell, 'mysql_row_tell');
          assign_proc(@mysql_field_tell, 'mysql_field_tell');
          assign_proc(@mysql_field_count, 'mysql_field_count');
          assign_proc(@mysql_affected_rows, 'mysql_affected_rows');
          assign_proc(@mysql_insert_id, 'mysql_insert_id');
          assign_proc(@mysql_errno, 'mysql_errno');
          assign_proc(@mysql_error, 'mysql_error');
          assign_proc(@mysql_info, 'mysql_info');
          assign_proc(@mysql_thread_id, 'mysql_thread_id');
          assign_proc(@mysql_character_set_name, 'mysql_character_set_name');
          assign_proc(@mysql_init, 'mysql_init');
          {$IFDEF HAVE_OPENSSL}
          assign_proc(@mysql_ssl_set, 'mysql_ssl_set');
          assign_proc(@mysql_ssl_cipher, 'mysql_ssl_cipher');
          assign_proc(@mysql_ssl_clear, 'mysql_ssl_clear');
          {$ENDIF} // HAVE_OPENSSL
          assign_proc(@mysql_connect, 'mysql_connect');
          assign_proc(@mysql_change_user, 'mysql_change_user');
          assign_proc(@mysql_real_connect, 'mysql_real_connect');
          assign_proc(@mysql_close, 'mysql_close');
          assign_proc(@mysql_select_db, 'mysql_select_db');
          assign_proc(@mysql_query, 'mysql_query');
          assign_proc(@mysql_send_query, 'mysql_send_query');
          assign_proc(@mysql_read_query_result, 'mysql_read_query_result');
          assign_proc(@mysql_real_query, 'mysql_real_query');
          assign_proc(@mysql_create_db, 'mysql_create_db');
          assign_proc(@mysql_drop_db, 'mysql_drop_db');
          assign_proc(@mysql_shutdown, 'mysql_shutdown');
          assign_proc(@mysql_dump_debug_info, 'mysql_dump_debug_info');
          assign_proc(@mysql_refresh, 'mysql_refresh');
          assign_proc(@mysql_kill, 'mysql_kill');
          assign_proc(@mysql_ping, 'mysql_ping');
          assign_proc(@mysql_stat, 'mysql_stat');
          assign_proc(@mysql_get_server_info, 'mysql_get_server_info');
          assign_proc(@mysql_get_client_info, 'mysql_get_client_info');
          assign_proc(@mysql_get_host_info, 'mysql_get_host_info');
          assign_proc(@mysql_get_proto_info, 'mysql_get_proto_info');
          assign_proc(@mysql_list_dbs, 'mysql_list_dbs');
          assign_proc(@mysql_list_tables, 'mysql_list_tables');
          assign_proc(@mysql_list_fields, 'mysql_list_fields');
          assign_proc(@mysql_list_processes, 'mysql_list_processes');
          assign_proc(@mysql_store_result, 'mysql_store_result');
          assign_proc(@mysql_use_result, 'mysql_use_result');
          assign_proc(@mysql_options, 'mysql_options');
          assign_proc(@mysql_free_result, 'mysql_free_result');
          assign_proc(@mysql_data_seek, 'mysql_data_seek');
          assign_proc(@mysql_row_seek, 'mysql_row_seek');
          assign_proc(@mysql_field_seek, 'mysql_field_seek');
          assign_proc(@mysql_fetch_row, 'mysql_fetch_row');
          assign_proc(@mysql_fetch_lengths, 'mysql_fetch_lengths');
          assign_proc(@mysql_fetch_field, 'mysql_fetch_field');
          assign_proc(@mysql_escape_string, 'mysql_escape_string');
          assign_proc(@mysql_real_escape_string, 'mysql_real_escape_string');
          assign_proc(@mysql_debug, 'mysql_debug');
          assign_proc(@mysql_odbc_escape_string, 'mysql_odbc_escape_string');
          assign_proc(@myodbc_remove_escape, 'myodbc_remove_escape');
          assign_proc(@mysql_thread_safe, 'mysql_thread_safe');
        end;
        Result := libmysql_status;
      end;

      procedure libmysql_free;
      begin
        if libmysql_handle <> 0 then FreeLibrary(libmysql_handle);
        libmysql_handle := 0;
        libmysql_status := LIBMYSQL_UNDEFINED;
      end;

// -----------------------------------------------------------------------------------------------
// Definitionen der Funktionen und Klassenmethoden aus mySQLCommon.pas

      procedure AddLog(sTemp : string);
      var
        T : TextFile;
      begin
        {$I-}
        AssignFile(T,DEBUGFILE_COMMON);

        if FileExists(DEBUGFILE_COMMON) then
          Append(T)
        else
          Rewrite(T);
        {$I+}

        if IOResult=0 then begin
          writeln(T,DateTimeToStr(Now)+' '+sTemp);
          CloseFile(T);
        end;
      end;

      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------

      constructor TmySQLClientQuery.Create;
      begin
        if (libmysql_status<>LIBMYSQL_READY) and (libmysql_status<>LIBMYSQL_INCOMPATIBLE) then exit;

        FTaskHandler:=nil;
        FFieldsLoaded :=FALSE;
        FCurrentTaskData:=nil;

        FData         :=TStringList.Create;
        FFields       :=TStringList.Create;
      end;

      destructor TmySQLClientQuery.Destroy;
      begin
        FData.Free;
        FFields.Free;

        inherited;
      end;

      procedure TmySQLClientQuery.Reset;
      begin
        FCurrentTaskData.Free;
        FCurrentTaskData:=nil;

        FFields.Clear;
        FFieldsLoaded:=FALSE;
        FData.Clear;
      end;

      procedure TmySQLClientQuery.Prepare(Query : pchar; const TaskName : string);
      begin
        PrepareTask(Query,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      procedure TmySQLClientQuery.PrepareTask(
        Query : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_query(
          task_mysql_store_result,

          Query,

          TaskName,

          _OnComplete,
          _OnError,

          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientQuery._OnComplete(Sender : TObject; Data : TObject);
      var
        key        : pchar;
        row        : pmysql_row;
        i          : integer;
        temp       : string;
        dokey      : boolean;
      begin
        FCurrentTaskData:=TmySQLClientTaskData(Data);

        if FCurrentTaskData.F_executetype=Execute_Stored then begin
          with FCurrentTaskData do begin
            if F_presults=nil then
              exit;

            dokey:=F_keyfield<(F_presults.field_count);
            temp:='';

            for i:=0 to F_presults.row_count-1 do begin
              row:=mysql_fetch_row(F_presults);
              if dokey then begin
                temp:='';
                key:=row^[F_keyfield];
                temp:=StrPas(key);
              end;
              FData.AddObject(temp,TObject(row));
            end;

            if Assigned(FTaskOnComplete) then
              FTaskOnComplete(Self);

            if FTaskHandler.FThreaded=TRUE then
              Reset;
          end;
        end;
      end;

      procedure TmySQLClientQuery._OnError(Sender: TObject; Data: TObject; Msg: string);
      var
        T          : TmySQLClientTaskData;
      begin
        if Data=nil then exit;

        T:=TmySQLClientTaskData(Data);

        if Assigned(T.FTaskOnError) then
          T.FTaskOnError(Self,Msg);

        Reset;
      end;

      function TmySQLClientQuery.Data(const i, j : longword) : pchar;
      var
        R : pmysql_row;
      begin
        Result:='';

        if FCurrentTaskData=nil then
          Result:=nil
        else with FCurrentTaskData do begin
          if F_presults=nil then exit;

          if i>=longword(FData.Count) then exit;

          if j>=(F_presults^.field_count) then exit;

          R:=pmysql_row(FData.Objects[i]);

          Result:=R^[j];
        end;
      end;

      function TmySQLClientQuery.DataAsInteger(const i, j : longword) : integer;
      begin
        Result:=-1;

        if Data(i,j)<>'' then begin
          try
            Result:=StrToInt(Data(i,j));
          except
          end;
        end;
      end;

      function TmySQLClientQuery.DataAsDateTime(const i, j : longword) : TDateTime;
      var
        Temp : string[19];
        yyyy : string[4];
        mm, dd, hh, nn, ss : string[2];
      begin
        Temp:=StrPas(Data(i,j));
        if Length(Temp)<>19 then begin Result:=0; exit; end;

        yyyy:=Copy(Temp,1,4);
        mm:=Copy(Temp,6,2);
        dd:=Copy(Temp,9,2);
        hh:=Copy(Temp,12,2);
        nn:=Copy(Temp,15,2);
        ss:=Copy(Temp,18,2);

        try
          Result:=StrToDateTime(mm+'/'+dd+'/'+yyyy+' '+hh+':'+nn+':'+ss);
        except
          Result:=0;
        end;
      end;

      function TmySQLClientQuery.GetFieldCount : integer;
      begin
        Result:=-1;

        if FCurrentTaskData <> nil then
        begin
          if FCurrentTaskData.F_presults=nil then exit;

          Result:=FCurrentTaskData.F_presults^.field_count;
        end;
      end;

      function TmySQLClientQuery.GetDataCount : integer;
      begin
        Result:=FData.Count;
      end;

      procedure TmySQLClientQuery.GetFields;
      var
        F : pmysql_field;
      begin
        if FCurrentTaskData <> nil then
        begin
          if FCurrentTaskData.F_presults=nil then exit;

          F:=mysql_fetch_field(FCurrentTaskData.F_presults);

          while (f<>nil) do begin
            FFields.AddObject(StrPas(F^.name),Pointer(F));

            F:=mysql_fetch_field(FCurrentTaskData.F_presults);
          end;

          FFieldsLoaded:=TRUE;
        end
      end;

      function TmySQLClientQuery.GetFieldName(const i : longint) : string;
      begin
        if FCurrentTaskData <> nil then
        begin
          if FCurrentTaskData.F_presults=nil then exit;

          if not FFieldsLoaded then GetFields;

          if i>=FFields.Count then exit;

          Result:=FFields[i];
        end else
          Result := 'Fehler! Keine Felder enthalten!';
      end;

      function TmySQLClientQuery.GetField(const i : longint) : pmysql_field;
      begin
        Result:=nil;

        if FCurrentTaskData <> nil then
        begin
          if FCurrentTaskData.F_presults=nil then exit;

          if not FFieldsLoaded then GetFields;

          if i>=FFields.Count then exit;

          Result:=Pointer(FFields.Objects[i]);
        end
      end;

      function TmySQLClientQuery.GetIndexByFieldName(const FieldString : string) : integer;
      begin
        Result:=-1;

        if FCurrentTaskData <> nil then
        begin
          if FCurrentTaskData.F_presults=nil then exit;

          if not FFieldsLoaded then GetFields;

          Result:=FFields.IndexOf(FieldString);
        end
      end;

      function TmySQLClientQuery.DataByFieldName(const i : longint; const FieldString : string) : pchar;
      var
        j : integer;
      begin
        Result:='';

        j:=GetIndexByFieldName(FieldString);

        if j<0 then exit;

        Result:=Data(i,j);
      end;

      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------

      destructor TmySQLClientModifyData.Destroy;
      begin
        StrDispose(pData);

        inherited;
      end;

      constructor TmySQLClientModify.Create;
      begin
        inherited Create;

        FTaskHandler:=nil;
  
        FData       :=TStringList.Create;
      end;

      destructor TmySQLClientModify.Destroy;
      begin
        Reset;

        FData.Free;

        inherited;
      end;

      procedure TmySQLClientModify.Reset;
      var
        i : integer;
        D : TmySQLClientModifyData;
      begin
        for i:=0 to FData.Count-1 do begin
          D:=TmySQLClientModifyData(FData.Objects[i]);
          D.Free;
        end;
        FData.Clear;
      end;

      procedure TmySQLClientModify.Add(const Column : string; Data : pchar);
      var
        D : TmySQLClientModifyData;
      begin
        D:=TmySQLClientModifyData.Create;
        D.pData:=StrAlloc(MAX_SQL_LENGTH);

        StrCopy(D.pData,Data);
        FData.AddObject(Column,D);
      end;

      procedure TmySQLClientModify.AddString(const Column : string; const Data : string);
      var
        D : TmySQLClientModifyData;
      begin
        D:=TmySQLClientModifyData.Create;
        D.pData:=StrAlloc(Length(Data)+1);
        StrPCopy(D.pData,Data);

        FData.AddObject(Column,D);
      end;

      procedure TmySQLClientModify.AddInteger(const Column : string; const Data : integer);
      var
        D : TmySQLClientModifyData;
        sTemp : string;
      begin
        sTemp:=IntToStr(Data);

        D:=TmySQLClientModifyData.Create;
        D.pData:=StrAlloc(Length(sTemp)+1);
        StrPCopy(D.pData,sTemp);

        FData.AddObject(Column,D);
      end;

      procedure TmySQLClientModify.AddMemo(const Column : string; Memo : TMemo);
      var
        iTemp : integer;
        pTemp : pchar;
      begin
        iTemp:=StrLen(Memo.Lines.GetText);
        if iTemp>0 then begin
          pTemp:=StrAlloc(MAX_MEMO_LENGTH);
          pTemp^:=#0;
          Add(Column,Quote(pTemp,Memo.Lines.GetText,iTemp,[QUOTE_STRIP_CR]));
          StrDispose(pTemp);
        end
        else
          Add(Column,'NULL');
      end;

      procedure TmySQLClientModify.Combine(T : TmySQLClientTaskData);
      var
        pStrTemp : array[0..255] of char;
        i : integer;
        D : TmySQLClientModifyData;
      begin
        with T do begin

        FillChar(F_query^,MAX_SQL_LENGTH,#0);

          case F_modifytype of
            MODIFY_CREATE_TABLE: begin
              StrCopy(F_query,'CREATE TABLE ');
              StrCat(F_query,StrPCopy(pStrTemp,F_table+' ('));

              for i:=0 to FData.Count-1 do begin
                D:=TmySQLClientModifyData(FData.Objects[i]);
                StrCat(F_query,StrPCopy(pStrTemp,FData.Strings[i]+' '));
                StrCat(F_query,D.pData);
                if i<>FData.Count-1 then
                  StrCat(F_query,',');
              end;

              StrCat(F_query,')');
            end;

            MODIFY_DROP_TABLE: begin
              StrPCopy(F_query,'DROP TABLE '+F_table);
            end;

            MODIFY_INSERT, MODIFY_REPLACE_INTO: begin
              if F_modifytype = MODIFY_UPDATE then
                StrCopy(F_query,'INSERT INTO ')
              else
                StrCopy(F_query,'REPLACE INTO ');

              StrCat(F_query,StrPCopy(pStrTemp,F_table+' ('));

              for i:=0 to FData.Count-1 do begin
                StrCat(F_query,StrPCopy(pStrTemp,FData.Strings[i]));
                if i<>FData.Count-1 then
                  StrCat(F_query,',');
              end;

              StrCat(F_query,') VALUES (');

              for i:=0 to FData.Count-1 do begin
                D:=TmySQLClientModifyData(FData.Objects[i]);
                StrCat(F_query,D.pData);
                if i<>FData.Count-1 then
                  StrCat(F_query,',');
              end;
              StrCat(F_query,')');

              if F_condition<>nil then begin
                StrCat(F_query,' ');
                StrCat(F_query,F_condition);
              end;
            end;

            MODIFY_UPDATE: begin
              StrCopy(F_query,'UPDATE ');

              StrCat(F_query,StrPCopy(pStrTemp,F_table+' SET '));

              for i:=0 to FData.Count-1 do begin
                D:=TmySQLClientModifyData(FData.Objects[i]);
                StrCat(F_query,StrPCopy(pStrTemp,FData.Strings[i]+'='));
                StrCat(F_query,D.pData);
                if i<>FData.Count-1 then
                  StrCat(F_query,',');
              end;
              if F_condition<>nil then begin
                StrCat(F_query,' ');
                StrCat(F_query,F_condition);
              end;
            end;

            MODIFY_DELETE: begin
              StrCopy(F_query,'DELETE FROM ');
              StrCat(F_query,StrPCopy(pStrTemp,F_table));

              if F_condition<>nil then begin
                StrCat(F_query,' ');
                StrCat(F_query,F_condition);
              end;
            end;
          end;
        end; {with}
      end;

      // ---------------

      procedure   TmySQLClientModify.PrepareModifySQL(pSQL: string;pTaskname: string);
      begin
        self.PrepareModifySQLTask(pSQL,pTaskname,FDefault_OnComplete,FDefault_OnError);
      end;

      procedure   TmySQLClientModify.PrepareModifySQLTask(
        pSQL: string;
        pTaskname: string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
        );
      var T: TmySQLClientTaskData;
      begin
        // puts SQL command line directly into F_Query without syntax checking
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=pTaskName;
          FPrepared   :=TRUE;
          F_table     :=''; // not needed
          // F_modifytype not needed
          // F_condition not needed
          FillChar(F_query^,MAX_SQL_LENGTH,#0);
          F_query     := StrPCopy(F_Query, pSQL);
        end;
        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,pTaskName,_OnComplete,_OnError,OnComplete,OnError);
        T.Free;
        Reset;
      end;

      procedure TmySQLClientModify.PrepareCreateTableTask(
        Table : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared   :=TRUE;
          F_table     :=Table;
          F_modifytype:=MODIFY_CREATE_TABLE;
          StrCopy(F_condition,'');
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,TaskName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        Reset;
      end;

      procedure TmySQLClientModify.PrepareCreateTable(Table : pchar; const TaskName : string);
      begin
        PrepareCreateTableTask(Table,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify.PrepareDropTableTask(
        Table : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared   :=TRUE;
          F_table     :=Table;
          F_modifytype:=MODIFY_DROP_TABLE;
          StrCopy(F_condition,'');
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,TaskName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        Reset;
      end;

      procedure TmySQLClientModify.PrepareDropTable(Table : pchar; const TaskName : string);
      begin
        PrepareDropTableTask(Table,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify.PrepareInsertTask(
        Table : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared   :=TRUE;
          F_table     :=Table;
          F_modifytype:=MODIFY_INSERT;
          StrCopy(F_condition,'');
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,T.FName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        Reset;
      end;

      procedure TmySQLClientModify.PrepareInsert(Table : pchar; const TaskName : string);
      begin
        PrepareInsertTask(Table,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify.PrepareUpdateTask(
        Table, Condition : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared  :=TRUE;
          F_table     :=Table;
          F_modifyType:=MODIFY_UPDATE;
          StrCopy(F_condition,Condition);
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,T.FName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        if FTaskHandler.FThreaded then Reset;
      end;

      procedure TmySQLClientModify.PrepareUpdate(Table, Condition : pchar; const TaskName : string);
      begin
        PrepareUpdateTask(Table,Condition,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify.PrepareUpdateStringTask(
        Table : pchar; const Condition : string;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared   :=TRUE;
          F_table     :=Table;
          F_modifytype:=MODIFY_UPDATE;
          StrPCopy(F_condition,Condition);
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,T.FName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        if FTaskHandler.FThreaded then Reset;
      end;

      procedure TmySQLClientModify.PrepareUpdateString(Table : pchar; const Condition : string; const TaskName : string);
      begin
        PrepareUpdateStringTask(Table,Condition,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify.PrepareReplaceIntoTask(
        Table, Condition : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared  :=TRUE;
          F_table     :=Table;
          F_modifyType:=MODIFY_REPLACE_INTO;
          StrCopy(F_condition,Condition);
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,T.FName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        if FTaskHandler.FThreaded then Reset;
      end;

      procedure TmySQLClientModify.PrepareReplaceInto(Table, Condition : pchar; const TaskName : string);
      begin
        PrepareReplaceIntoTask(Table,Condition,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify.PrepareReplaceIntoStringTask(
        Table : pchar; const Condition : string;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared   :=TRUE;
          F_table     :=Table;
          F_modifytype:=MODIFY_REPLACE_INTO;
          StrPCopy(F_condition,Condition);
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,T.FName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        if FTaskHandler.FThreaded then Reset;
      end;

      procedure TmySQLClientModify.PrepareReplaceIntoString(Table : pchar; const Condition : string; const TaskName : string);
      begin
        PrepareReplaceIntoStringTask(Table,Condition,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify.PrepareDeleteTask(
        Table, Condition : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared   :=TRUE;
          F_table     :=Table;
          F_modifytype:=MODIFY_DELETE;
          StrCopy(F_condition,Condition);
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,T.FName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        if FTaskHandler.FThreaded then Reset;
      end;

      procedure TmySQLClientModify.PrepareDelete(Table, Condition : pchar; const TaskName : string);
      begin
        PrepareDeleteTask(Table,Condition,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify.PrepareDeleteStringTask(
        Table : pchar; const Condition : string;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;
          FPrepared   :=TRUE;
          F_table     :=Table;
          F_modifytype:=MODIFY_DELETE;
          StrPCopy(F_condition,Condition);
        end;

        Combine(T);

        FTaskHandler.Thread.Prepare_mysql_query(task_mysql_query,T.F_Query,T.FName,_OnComplete,_OnError,OnComplete,OnError);

        T.Free;

        if FTaskHandler.FThreaded then Reset;
      end;

      procedure TmySQLClientModify.PrepareDeleteString(Table : pchar; const Condition : string; const TaskName : string);
      begin
        PrepareDeleteStringTask(Table,Condition,TaskName,FDefault_OnComplete,FDefault_OnError);
      end;

      // ---------------

      procedure TmySQLClientModify._OnComplete(Sender : TObject; Data : TObject);
      var
        FTaskOnComplete : TmySQLClientTask_OnComplete;
      begin
        FCurrentTaskData:=TmySQLClientTaskData(Data);
        if FCurrentTaskData=nil then exit;
        FTaskOnComplete:=FCurrentTaskData.FTaskOnComplete;

        FCurrentTaskData.Free;

        if Assigned(FTaskOnComplete) then
          FTaskOnComplete(Self);
      end;

      procedure TmySQLClientModify._OnError(Sender: TObject; Data: TObject; Msg: string);
      var
        FTaskOnError : TmySQLClientTask_OnError;
      begin
        FCurrentTaskData:=TmySQLClientTaskData(Data);
        if FCurrentTaskData=nil then exit;
        FTaskOnError:=FCurrentTaskData.FTaskOnError;

        FCurrentTaskData.Free;

        if Assigned(FTaskOnError) then
          FTaskOnError(Self,Msg);
      end;

      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------

      constructor TmySQLClientUtility.Create;
      begin
        inherited;

        FTaskHandler                 :=nil;
        FCurrentTaskData             :=nil;

        Default_OnSelectDatabase     :=nil;
        Default_OnSelectDatabaseError:=nil;

        Default_OnCreateDatabase     :=nil;
        Default_OnCreateDatabaseError:=nil;

        Default_OnDropDatabase       :=nil;
        Default_OnDropDatabaseError  :=nil;

        Default_OnListDatabases      :=nil;
        Default_OnListDatabasesError :=nil;

        Default_OnListTables         :=nil;
        Default_OnListTablesError    :=nil;

        Default_OnListFields         :=nil;
        Default_OnListFieldsError    :=nil;

        Default_OnListProcesses      :=nil;
        Default_OnListProcessesError :=nil;

        Default_OnPing               :=nil;
        Default_OnPingError          :=nil;

        Default_OnShutdown           :=nil;
        Default_OnShutdownError      :=nil;

        Default_OnKill               :=nil;
        Default_OnKillError          :=nil;

        Default_OnOptions            :=nil;
        Default_OnOptionsError       :=nil;

        Default_OnRefresh            :=nil;
        Default_OnRefreshError       :=nil;
      end;

      destructor TmySQLClientUtility.Destroy;
      begin
       if FCurrentTaskData<>nil then
       begin
          FCurrentTaskData.Free;
          FCurrentTaskData:=nil
       end;
       inherited;
      end;

      procedure TmySQLClientUtility._OnComplete(Sender: TObject; Data: TObject);
      var
        FTaskOnComplete : TmySQLClientTask_OnComplete;
      begin
        if FCurrentTaskData<>nil then
        begin
          FCurrentTaskData.Free;
          FCurrentTaskData:=nil
        end;
        FCurrentTaskData:=TmySQLClientTaskData(Data);
        if FCurrentTaskData=nil then exit;

        FTaskOnComplete:=FCurrentTaskData.FTaskOnComplete;

      //  FCurrentTaskData.Free; // ?

        if Assigned(FTaskOnComplete) then
          FTaskOnComplete(Self);
      end;

      procedure TmySQLClientUtility._OnError(Sender: TObject; Data: TObject; Msg: string);
      var
        FTaskOnError : TmySQLClientTask_OnError;
      begin
        if FCurrentTaskData<>nil then
        begin
          FCurrentTaskData.Free;
          FCurrentTaskData:=nil
        end;
        FCurrentTaskData:=TmySQLClientTaskData(Data);
        if FCurrentTaskData=nil then exit;

        FTaskOnError:=FCurrentTaskData.FTaskOnError;

      //  FCurrentTaskData.Free; // ?

        if Assigned(FTaskOnError) then
          FTaskOnError(Self,Msg);
      end;

      procedure TmySQLClientUtility.PrepareConnectTask(
        const host, user, passwd, db: pchar;
        port: Cardinal; unix_socket: PChar; clientflag: Cardinal;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_real_connect(
          PChar(host),
          PChar(user),
          PChar(passwd),
          PChar(db),
          port,nil,clientflag,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareCloseTask(
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_close(
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareSelectDatabase(
        db : pchar;
        const TaskName : string
      );
      begin
        PrepareSelectDatabaseTask(
          db,
          TaskName,
          Default_OnSelectDatabase,
          Default_OnSelectDatabaseError
        );
      end;

      procedure TmySQLClientUtility.PrepareSelectDatabaseTask(
        db : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_db(
          task_mysql_select_db,
          db,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareCreateDatabase(
        db : pchar;
        const TaskName : string
      );
      begin
        PrepareCreateDatabaseTask(
          db,
          TaskName,
          Default_OnCreateDatabase,
          Default_OnCreateDatabaseError
        );
      end;

      procedure TmySQLClientUtility.PrepareCreateDatabaseTask(
        db : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_db(
          task_mysql_create_db,
          db,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareDropDatabase(
        db : pchar;
        const TaskName : string
      );
      begin
        PrepareDropDatabaseTask(
          db,
          TaskName,
          Default_OnDropDatabase,
          Default_OnDropDatabaseError
        );
      end;

      procedure TmySQLClientUtility.PrepareDropDatabaseTask(
        db : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_db(
          task_mysql_drop_db,
          db,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareListDatabases(
        Wild : pchar;
        const TaskName : string
      );
      begin
        PrepareListDatabasesTask(
          Wild,
          TaskName,
          Default_OnListDatabases,
          Default_OnListDatabasesError
        );
      end;

      procedure TmySQLClientUtility.PrepareListDatabasesTask(
        Wild : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_list(
          task_mysql_list_db,
          Wild,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareListTables(
        Wild : pchar;
        const TaskName : string
      );
      begin
        PrepareListTablesTask(
          Wild,
          TaskName,
          Default_OnListTables,
          Default_OnListTablesError
        );
      end;

      procedure TmySQLClientUtility.PrepareListTablesTask(
        Wild : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_list(
          task_mysql_list_tables,
          Wild,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareListFields(
        TableName : pchar;
        Wild : pchar;
        const TaskName : string
      );
      begin
        PrepareListFieldsTask(
          TableName,
          Wild,
          TaskName,
          Default_OnListFields,
          Default_OnListFieldsError
        );
      end;

      procedure TmySQLClientUtility.PrepareListFieldsTask(
        TableName : pchar;
        Wild : pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_list_fields(
          TableName,
          Wild,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareListProcesses(
        const TaskName : string
      );
      begin
        PrepareListProcessesTask(
          TaskName,
          Default_OnListProcesses,
          Default_OnListProcessesError
        );
      end;

      procedure TmySQLClientUtility.PrepareListProcessesTask(
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_list_processes(
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PreparePing(
        const TaskName : string
      );
      begin
        PreparePingTask(
          TaskName,
          Default_OnPing,
          Default_OnPingError
        );
      end;

      procedure TmySQLClientUtility.PreparePingTask(
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_ping_shutdown(
          task_mysql_ping,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareShutdown(
        const TaskName : string
      );
      begin
        PrepareShutdownTask(
          TaskName,
          Default_OnShutdown,
          Default_OnShutdownError
        );
      end;

      procedure TmySQLClientUtility.PrepareShutdownTask(
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_ping_shutdown(
          task_mysql_shutdown,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareKill(
        const pid : integer;
        const TaskName : string
      );
      begin
        PrepareKillTask(
          pid,
          TaskName,
          Default_OnKill,
          Default_OnKillError
        );
      end;

      procedure TmySQLClientUtility.PrepareKillTask(
        const pid : integer;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_kill(
          pid,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareOptions(
        const opt: mysql_option; arg: pchar;
        const TaskName : string
      );
      begin
        PrepareOptionsTask(
          opt,
          arg,
          TaskName,
          Default_OnOptions,
          Default_OnOptionsError
        );
      end;

      procedure TmySQLClientUtility.PrepareOptionsTask(
        const opt: mysql_option; arg: pchar;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      begin
        FTaskHandler.Thread.Prepare_mysql_options(
          opt,
          arg,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      procedure TmySQLClientUtility.PrepareRefresh(
        const RefreshOptions: TSetRefreshOptions;
        const TaskName : string
      );
      begin
        PrepareRefreshTask(
          RefreshOptions,
          TaskName,
          Default_OnRefresh,
          Default_OnRefreshError
        );
      end;

      procedure TmySQLClientUtility.PrepareRefreshTask(
        const RefreshOptions: TSetRefreshOptions;
        const TaskName : string;
        OnComplete : TmySQLClientTask_OnComplete;
        OnError    : TmySQLClientTask_OnError
      );
      var
        Opt : cardinal;
      begin
        Opt:=0;

        if (_REFRESH_GRANT  in RefreshOptions) then Opt:=Opt+REFRESH_GRANT;
        if (_REFRESH_LOG    in RefreshOptions) then Opt:=Opt+REFRESH_LOG;
        if (_REFRESH_TABLES in RefreshOptions) then Opt:=Opt+REFRESH_TABLES;
        if (_REFRESH_HOSTS  in RefreshOptions) then Opt:=Opt+REFRESH_HOSTS;
        if (_REFRESH_STATUS  in RefreshOptions) then Opt:=Opt+REFRESH_STATUS;
        if (_REFRESH_THREADS  in RefreshOptions) then Opt:=Opt+REFRESH_THREADS;
        if (_REFRESH_SLAVE  in RefreshOptions) then Opt:=Opt+REFRESH_SLAVE;
        if (_REFRESH_MASTER  in RefreshOptions) then Opt:=Opt+REFRESH_MASTER;

        FTaskHandler.Thread.Prepare_mysql_refresh(
          Opt,
          TaskName,
          _OnComplete,
          _OnError,
          OnComplete,
          OnError
        );
      end;

      function TmySQLClientUtility.GetServerInfo : string;
      begin
        Result:=mysql_get_server_info(FTaskHandler.Session);
      end;

      function TmySQLClientUtility.GetClientInfo : string;
      begin
        Result:=mysql_get_client_info;
      end;

      function TmySQLClientUtility.GetHostInfo : string;
      begin
        Result:=mysql_get_host_info(FTaskHandler.Session);
      end;

      function TmySQLClientUtility.GetProtoInfo : byte;
      begin
        Result:=mysql_get_proto_info(FTaskHandler.Session);
      end;

      function TmySQLClientUtility.GetErrorMsg : string;
      begin
        Result:=FTaskHandler.Session.net.last_error;
      end;

      function TmySQLClientUtility.GetStat : pchar;
      begin
        Result:=mysql_stat(FTaskHandler.Session);
      end;

      function TmySQLClientUtility.GetListResult : TStringList;
      begin
        Result:=nil;

        if FCurrentTaskData=nil then exit;

        Result:=FCurrentTaskData.F_ListData;
      end;

      function TmySQLClientUtility.GetIntegerResult : integer;
      begin
        Result:=-1;

        if FCurrentTaskData=nil then exit;

        Result:=FCurrentTaskData.F_IntegerData;
      end;

      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------

      constructor TmySQLClientTaskData.Create;
      begin
        F_query       :=StrAlloc(MAX_SQL_LENGTH);

        FTaskType     :=task_mysql_connect;
        FPrepared     :=FALSE;

        F_host  :=StrAlloc(MAX_LENGTH_HOST+1);
        F_user  :=StrAlloc(MAX_LENGTH_USER+1);
        F_passwd:=StrAlloc(MAX_LENGTH_PASSWD+1);
        F_db    :=StrAlloc(MAX_LENGTH_DB+1);

        F_port        :=0;
        F_unix_socket :='';
        F_clientflag  :=0;
        F_presults    :=nil;
        F_Session     :=nil;
        F_ret_code    :=0;
        F_keyfield    :=0;
        F_executetype :=Execute_Stored;
        F_table       :='';
        F_condition   :=StrAlloc(MAX_SQL_LENGTH);

        F_ListData       :=TStringList.Create;
        F_IntegerData    :=-1;

        FThreadOnComplete:=nil;
        FThreadOnError   :=nil;

        FTaskOnComplete  :=nil;
        FTaskOnError     :=nil;
      end;

      destructor TmySQLClientTaskData.Destroy;
      begin
        if F_presults<>nil then begin
          mysql_free_result(F_presults);
        end;

        F_ListData.Free;

        StrDispose(F_host);
        StrDispose(F_user);
        StrDispose(F_passwd);
        StrDispose(F_db);

        StrDispose(F_query);
        StrDispose(F_condition);

        inherited;
      end;

      constructor TmySQLClientThread.Create(CreateSuspended : boolean);
      begin
        inherited;

        FTaskList:=TList.Create;
        FThreaded:=TRUE;
        FOnStatus:=nil;
      end;

      destructor TmySQLClientThread.Destroy;
      begin
        FTaskList.Free;
      end;

      function TmySQLClientThread.GetTaskCount : integer;
      begin
        Result:=FTaskList.Count;
      end;

      procedure TmySQLClientThread.Prepare_mysql_real_connect(
        const host, user, passwd, db: pchar;
        port: Cardinal; unix_socket: PChar; clientflag: Cardinal;
        const TaskName : string;
        OnComplete : TmySQLClientThread_OnComplete;
        OnError    : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName        :=TaskName;

          FPrepared    :=TRUE;
          FTaskType    :=task_mysql_real_connect;

          StrCopy(F_Host  ,host);
          StrCopy(F_User  ,user);
          StrCopy(F_Passwd,passwd);
          StrCopy(F_db    ,db);

          F_port       :=port;
          F_unix_socket:=unix_socket;
          F_clientflag :=clientflag;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Insert(0,T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_close(
        const TaskName : string;
        OnComplete : TmySQLClientThread_OnComplete;
        OnError    : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName        :=TaskName;

          FPrepared    :=TRUE;
          FTaskType    :=task_mysql_close;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_query(
        TaskType : TmySQLClientTaskType;
        _query: pchar;

        const TaskName : string;

        OnComplete : TmySQLClientThread_OnComplete;
        OnError    : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          StrCopy(F_query,_query);

          FPrepared   :=TRUE;
          FTaskType   :=TaskType;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_db(
        TaskType : TmySQLClientTaskType;
        db: pchar;

        const TaskName : string;

        OnComplete : TmySQLClientThread_OnComplete;
        OnError    : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          StrCopy(F_db    ,db);

          FPrepared   :=TRUE;
          FTaskType   :=TaskType;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_list(
        const TaskType : TmySQLClientTaskType;

        Wild : pchar;

        const TaskName : string;

        OnComplete     : TmySQLClientThread_OnComplete;
        OnError        : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          F_Wild      :=Wild;

          FPrepared   :=TRUE;
          FTaskType   :=TaskType;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_list_fields(
        TableName : pchar;
        Wild : pchar;

        const TaskName : string;

        OnComplete     : TmySQLClientThread_OnComplete;
        OnError        : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          F_Table     :=TableName;
          F_Wild      :=Wild;

          FPrepared   :=TRUE;
          FTaskType   :=task_mysql_list_fields;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_list_processes(
        const TaskName : string;

        OnComplete     : TmySQLClientThread_OnComplete;
        OnError        : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          FPrepared   :=TRUE;
          FTaskType   :=task_mysql_list_processes;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_ping_shutdown(
        const TaskType : TmySQLClientTaskType;
        const TaskName : string;

        OnComplete     : TmySQLClientThread_OnComplete;
        OnError        : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          FPrepared   :=TRUE;
          FTaskType   :=TaskType;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_kill(
        const pid : integer;
        const TaskName : string;

        OnComplete     : TmySQLClientThread_OnComplete;
        OnError        : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          F_pid       :=pid;

          FPrepared   :=TRUE;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_options(
        const opt: mysql_option; arg: pchar;
        const TaskName : string;

        OnComplete     : TmySQLClientThread_OnComplete;
        OnError        : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          F_Options   :=Opt;

          FPrepared   :=TRUE;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.Prepare_mysql_refresh(
        const RefreshOptions: cardinal;
        const TaskName : string;

        OnComplete     : TmySQLClientThread_OnComplete;
        OnError        : TmySQLClientThread_OnError;

        OnTaskComplete : TmySQLClientTask_OnComplete;
        OnTaskError    : TmySQLClientTask_OnError
      );
      var
        T : TmySQLClientTaskData;
      begin
        T:=TmySQLClientTaskData.Create;

        with T do begin
          FName       :=TaskName;

          F_Refresh_Options:=RefreshOptions;

          FPrepared   :=TRUE;

          FThreadOnComplete:=OnComplete;
          FThreadOnError   :=OnError;

          FTaskOnComplete:=OnTaskComplete;
          FTaskOnError   :=OnTaskError;
        end;

        FTaskList.Add(T);
      end;

      procedure TmySQLClientThread.PostComplete(T : TmySQLClientTaskData);
      var
        sTemp : string;
        iCount : integer;
      begin
        sTemp:=''; iCount:=-1;

        if FThreaded then begin
          if Assigned(T.FThreadOnComplete) or
             Assigned(FOnFinished) or
             Assigned(FOnStatus) then
            PostMessage(FHandlerWndHandle,
              WM_CHAINTASKHANDLER_COMPLETE,
              LongWord(T),
              0
            );
        end else begin
          if Assigned(FOnStatus) then begin
            sTemp:=T.FName;
            iCount:=FTaskList.Count;
          end;
          if Assigned(T.FThreadOnComplete) then
            T.FThreadOnComplete(Self,T);
          if Assigned(FOnFinished) then
            FOnFinished(Self);
          if Assigned(FOnStatus) then
              FOnStatus(Self,mysql_status_active,sTemp,iCount);
        end;
      end;

      procedure TmySQLClientThread.PostError(T : TmySQLClientTaskData);
      begin
        if Assigned(T.FThreadOnError) then begin
          if FThreaded then
            PostMessage(FHandlerWndHandle,
              WM_CHAINTASKHANDLER_ERROR,
              LongWord(T),
              0
            )
          else
            T.FThreadOnError(Self,T,Session.net.last_error);
        end;
      end;

      procedure TmySQLClientThread.Execute;
      var
        T : TmySQLClientTaskData;
      begin
        if Terminated then exit;

        repeat
          if FTaskList.Count>0 then begin
            T:=TmySQLClientTaskData(FTaskList.Items[0]);
            FTaskList.Delete(FTaskList.IndexOf(T));
            Run(T);
          end else if (not Terminated) then begin
            Suspended:=TRUE;
          end;
        until Terminated;
      end;

      procedure TmySQLClientThread.ResumeNonThread;
      var
        T : TmySQLClientTaskData;
      begin
        repeat
          if FTaskList.Count>0 then begin
            T:=TmySQLClientTaskData(FTaskList.Items[0]);
            FTaskList.Delete(FTaskList.IndexOf(T));
            Run(T);
          end;
        until FTaskList.Count=0;
      end;

      procedure TmySQLClientThread.Run(T : TmySQLClientTaskData);
      begin
        with T do begin
          F_presults:=nil;
          F_ret_code:=-1;

          try
            case FTaskType of
              task_mysql_connect: begin
                mysql_init(Session);
                F_Session:=mysql_connect(Session,F_host,F_user,F_passwd);
              end;

              task_mysql_real_connect: begin
                mysql_init(Session);
                F_Session:=mysql_real_connect(Session,F_host,F_user,F_passwd,F_db,F_port,F_unix_socket,F_clientflag)
              end;

              task_mysql_close: begin
                mysql_close(Session);
              end;

              task_mysql_select_db: begin
                F_ret_code:=mysql_select_db(Session,F_db);
              end;

              task_mysql_create_db: begin
                F_ret_code:=mysql_create_db(Session,F_db);
              end;

              task_mysql_drop_db: begin
                F_ret_code:=mysql_drop_db(Session,F_db);
              end;

              task_mysql_query: begin
                F_ret_code:=mysql_query(Session,F_query);
              end;

              task_mysql_store_result: begin
                F_ret_code:=mysql_query(Session,F_query);

                if F_ret_code<0 then begin
                  F_presults:=nil;
                  F_ret_code:=-1;
                  PostError(T);
                  exit;
                end
                else
                  F_presults:=mysql_store_result(Session);
              end;

              task_mysql_list_db: begin
                F_presults:=mysql_list_dbs(Session,F_Wild);
              end;

              task_mysql_list_tables: begin
                F_presults:=mysql_list_tables(Session,F_Wild);
              end;

              task_mysql_list_fields: begin
                F_presults:=mysql_list_fields(Session,F_Table,F_Wild);
              end;

              task_mysql_list_processes: begin
                F_presults:=mysql_list_processes(Session);
              end;

              task_mysql_ping: begin
                F_ret_code:=mysql_ping(Session);
              end;

              task_mysql_shutdown: begin
                F_ret_code:=mysql_shutdown(Session);
              end;

              task_mysql_kill: begin
                F_ret_code:=mysql_kill(Session,F_pid);
              end;

              task_mysql_options: begin
                F_ret_code:=mysql_options(Session,F_options,F_arg);
              end;

              task_mysql_refresh: begin
                F_ret_code:=mysql_refresh(Session,Ord(F_refresh_options));
              end;
            end;
          except
            F_presults:=nil;
            F_ret_code:=-1;
            PostError(T);
          end;
        end;

        Finish(T);
      end;

      procedure TmySQLClientThread.Finish(T : TmySQLClientTaskData);
      var
        field : pmysql_field;
        row : pmysql_row;
        i : integer;
      begin
        with T do begin
          case FTaskType of
           task_mysql_connect, task_mysql_real_connect: begin
              if (F_Session=nil) then begin
                PostError(T)
              end else
                PostComplete(T);
            end;

            task_mysql_close: begin
              PostComplete(T);
            end;

            task_mysql_select_db, task_mysql_ping, task_mysql_shutdown,
            task_mysql_kill, task_mysql_options, task_mysql_refresh: begin
              if (F_ret_code<>0) then begin
                PostError(T)
              end else begin
                PostComplete(T)
              end;
            end;

            task_mysql_create_db, task_mysql_drop_db, task_mysql_query: begin
              if (F_ret_code<0) then begin
                PostError(T)
              end else begin
                PostComplete(T)
              end;
            end;

            task_mysql_store_result: begin
              if (F_presults=nil) then begin
                PostError(T)
              end else begin
                PostComplete(T)
              end;
            end;

            task_mysql_list_db, task_mysql_list_tables: begin
              if (F_presults=nil) then begin
                PostError(T)
              end else begin
                if F_ListData<>nil then begin
                  for i:=0 to F_presults^.row_count-1 do begin
                    row:=mysql_fetch_row(F_presults);
                    F_ListData.Add(StrPas(PChar(row[0])));
                  end;
                end;
                PostComplete(T)
              end;
            end;

            task_mysql_list_fields: begin
              if (F_presults=nil) then begin
                PostError(T)
              end else begin
                if F_ListData<>nil then begin
                  for i:=0 to F_presults^.field_count-1 do begin
                    field:=mysql_fetch_field(F_presults);
                    F_ListData.Add(StrPas(field^.table)+'.'+StrPas(field^.name));
                  end;
                end;
                PostComplete(T);
              end;
            end;

            task_mysql_list_processes: begin
              if (F_presults=nil) then begin
                PostError(T)
              end else begin
                if F_ListData<>nil then begin
                  for i:=0 to F_presults^.row_count-1 do begin
                    row:=mysql_fetch_row(F_presults);
                    F_ListData.Add(StrPas(PChar(row[0])));
                  end;
                end;
                PostComplete(T);
              end;
            end;

          end; {case}
        end; {with}
      end;

      constructor TmySQLClientTaskHandler.Create(const BThreaded : boolean);
      begin
        inherited Create;

        FWndHandle               :=AllocateHWnd(WndProc);

        FThread                  :=TmySQLClientThread.Create(TRUE);
        FThread.FHandlerWndHandle:=FWndHandle;
        FThread.FreeOnTerminate  :=FALSE;

        Threaded                 :=BThreaded;
      end;

      destructor TmySQLClientTaskHandler.Destroy;
      begin
        FThread.Terminate;
        FThread.Resume;
        FThread.WaitFor;
        FThread.Free;

        DestroyWindow(FWndHandle);

        inherited;
      end;

      function  TmySQLClientTaskHandler.GetSession : pmysql;
      begin
        Result:=FThread.Session;
      end;

      procedure TmySQLClientTaskHandler.SetSession(Session : pmysql);
      begin
        FThread.Session:=Session;
      end;

      function TmySQLClientTaskHandler.GetThreaded : boolean;
      begin
        Result:=FThreaded;
      end;

      procedure TmySQLClientTaskHandler.SetThreaded(B : boolean);
      begin
        FThreaded:=B;
        FThread.FThreaded:=B;
      end;

      procedure TmySQLClientTaskHandler.StartTasks;
      begin
        if FThreaded then begin

          if FThread.Suspended then
            FThread.Resume;

        end else
          FThread.ResumeNonThread;
      end;

      procedure TmySQLClientTaskHandler.DumpTasks;
      var
        i : integer;
        T : TmySQLClientTaskData;
      begin
        for i:=0 to Thread.FTaskList.Count-1 do begin
          T:=TmySQLClientTaskData(Thread.FTaskList[i]);
          T.Free;
        end;
        Thread.FTaskList.Clear;
      end;

      procedure TmySQLClientTaskHandler.WndProc(var Mesg : TMessage);
      var
        T : TmySQLClientTaskData;
        TaskType : TmySQLClientTaskType;
      begin
        with Mesg do begin
          if Msg = WM_CHAINTASKHANDLER_COMPLETE then begin
            T:=TmySQLClientTaskData(Mesg.wparam);
            TaskType:=T.FTaskType;

            if (Assigned(FThread.FOnStatus)) then
              FThread.FOnStatus(Self,mySQL_Status_Active,T.FName,FThread.FTaskList.Count+1);

            if Assigned(T.FThreadOnComplete) then
              T.FThreadOnComplete(Self,T);

            if (Assigned(FThread.FOnFinished)) then
              FThread.FOnFinished(Self);

            if (FThread.FTaskList.Count=0) then begin
              if (Assigned(FThread.FOnStatus)) then begin
                if TaskType=task_mysql_close then
                  FThread.FOnStatus(Self,mySQL_Status_NotConnected,'[Session Closed]',0)
                else
                  FThread.FOnStatus(Self,mySQL_Status_Idle,'[Idle]',0);
              end;
            end;
          end else
          if Msg = WM_CHAINTASKHANDLER_ERROR then begin
            T:=TmySQLClientTaskData(Mesg.wparam);

            if Assigned(T.FThreadOnError) then
                T.FThreadOnError(Self,T,Session.net.last_error);
          end else
            Result := DefWindowProc(FWndHandle, Msg, wParam, lParam);
        end;
      end;

      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------

      function Quote(pout, pin : pchar; var len : integer; const Options : TQuoteOptionsSet) : pchar;
      var
        i : integer;
        pTemp : array[0..1] of char;
      begin
        if (pin^=#0) and (not (QUOTE_DONT_USE_NULL in Options)) then begin
          StrCat(pout,'NULL');
          Result:=pout;
          exit;
        end;

        if not (QUOTE_DONT_INSERT_SINGLEQUOTES in Options) then
          StrCat(pout,''''); // Add initial "quote" for string data

        for i:=0 to len-1 do begin
          case pin[i] of

            #0:   StrCat(pout,'\0');  { Must be escaped for 'mysql' }

            #13:  if not (QUOTE_STRIP_LF in Options) then StrCat(pout,'\n');  { Must be escaped for logs }

            #10:  if not (QUOTE_STRIP_CR in Options) then StrCat(pout,'\r');

            '\':  StrCat(pout,'\\');

            '''': StrCat(pout,'\''');

            '"':  StrCat(pout,'\"');

            else begin
              pTemp[0]:=pin[i];
              pTemp[1]:=#0;
              StrCat(pout,pTemp);
            end;
          end;
        end;

        if not (QUOTE_DONT_INSERT_SINGLEQUOTES in Options) then
          StrCat(pout,''''); // Add final "quote" for string data

        Len:=StrLen(pout);
        Result:=pout;
      end;

      function QuoteString(sIn : string; const Options : TQuoteOptionsSet) : string;
      var
        p1, p2 : array[0..255] of char;
        i : integer;
      begin
        FillChar(p1,255,#0);
        FillChar(p2,255,#0);
        StrPCopy(p2,sIn);
        i:=Length(sIn);

        Quote(p1,p2,i,Options);

        Result:=StrPas(p1);
      end;

      {
      function EscapeString(const S : string) : string; - Broken in DLL?
      var
        p1, p2 : array[0..255] of char;
      begin
        StrPCopy(p2,S); FillChar(p1,255,#0);

        mysql_escape_string(p1,p2,length(S));

        Result:=StrPas(p1);
      end;
      }

      //
      // Copyright (c) 2001 Justin P. Yunke and others...(see top)
      //




// -----------------------------------------------------------------------------------------------

      constructor TCustom_mySQLClient.Create(AOwner : TComponent);
      begin
        inherited Create(AOwner);

        FConnected               :=FALSE;

        FConnectedTimer          :=nil;
        FConnectedTimeOutInterval:=DEFAULT_CONNECTED_TIMEOUT_INTERVAL;
        FTimedOut                :=FALSE;

        FBlockOnClose            :=TRUE;

        FThreaded                :=FALSE;

        FTaskHandler             :=TmySQLClientTaskHandler.Create(FThreaded);
        FTaskHandler.Session     :=@Fsession;
        FTaskHandler.Thread.OnFinished:=_OnTaskFinished;

        FUtility                 :=TmySQLClientUtility.Create;
        FUtility.TaskHandler     :=FTaskHandler;
        FQuery                   :=nil;
        FModify                  :=nil;

        FHost                    :='localhost';
        FUser                    :='';
        FPasswd                  :='';
        FDb                      :='';
        FPort                    :=MYSQL_PORT;
        FCapabilities            :=[_CLIENT_LONG_PASSWORD,_CLIENT_CONNECT_WITH_DB];

        FOnConnect               :=nil;
        FOnConnectError          :=nil;

        FOnQuery                 :=nil;
        FOnQueryError            :=nil;

        FOnModify                :=nil;
        FOnModifyError           :=nil;

        FOnSelectDatabase        :=nil;
        FOnSelectDatabaseError   :=nil;
      end;

      destructor  TCustom_mySQLClient.Destroy;
      begin
        ForceClose;

        FTaskHandler.Free;

        FModify.Free;
        FQuery.Free;
        FUtility.Free;

        inherited Destroy;
      end;

      function TCustom_mySQLClient.CreateQuery : TmySQLClientQuery;
      var
        Q : TmySQLClientQuery;
      begin
        Result:=nil;

        if ((libmysql_status<>LIBMYSQL_READY) and (libmysql_status<>LIBMYSQL_INCOMPATIBLE)) or (not FConnected) then exit;

        Q:=TmySQLClientQuery.Create;
        Q.TaskHandler       :=FTaskHandler;
        with Q do begin
          Default_OnComplete:=FOnQuery;
          Default_OnError   :=FOnQueryError;
        end;

        Result:=Q;
      end;

      function TCustom_mySQLClient.CreateModify : TmySQLClientModify;
      var
        M : TmySQLClientModify;
      begin
        Result:=nil;

        if ((libmysql_status<>LIBMYSQL_READY) and (libmysql_status<>LIBMYSQL_INCOMPATIBLE)) or (not FConnected) then exit;

        M:=TmySQLClientModify.Create;
        M.TaskHandler       :=FTaskHandler;
        with M do begin
          Default_OnComplete:=FOnModify;
          Default_OnError   :=FOnModifyError;
        end;

        Result:=M;
      end;

      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------

      procedure TCustom_mySQLClient.Connect;
      begin
        if FConnected then exit;

        if (libmysql_status<>LIBMYSQL_READY) and (libmysql_status<>LIBMYSQL_INCOMPATIBLE) then begin
          if FDLLPath='' then
            libmysql_load(nil)
          else
            libmysql_load(PChar(FDLLPath));
        end;

        if (libmysql_status<>LIBMYSQL_READY) and (Assigned(FOnConnectError)) then
          case libmysql_status of
            LIBMYSQL_MISSING: begin
              FOnConnectError(Self,'DLL nicht gefunden. Bitte stellen Sie sicher, dass libmysql.dll verfgbar ist.');
              exit;
            end;
            LIBMYSQL_INCOMPATIBLE: begin
              FOnConnectError(Self,'DLL Kompatibilittsproblem. Bitte berprfen Sie die Version! Client DLL Info: '+mysql_get_client_info);
            end;
            else begin
              FOnConnectError(Self,'DLL-Problem. Bitte stellen Sie sicher, dass libmysql.dll verfgbar ist.');
              exit;
            end;
          end;

        FTaskHandler.Thread.OnStatus:=OnStatus;

        if Assigned(FOnStatus) then
          FOnStatus(Self,mysql_Status_Connecting,'[Connect]',0);

        FCap:=0;
        if (_CLIENT_LONG_PASSWORD   in FCapabilities) then FCap:=FCap+CLIENT_LONG_PASSWORD;
        if (_CLIENT_FOUND_ROWS      in FCapabilities) then FCap:=FCap+CLIENT_FOUND_ROWS;
        if (_CLIENT_LONG_FLAG       in FCapabilities) then FCap:=FCap+CLIENT_LONG_FLAG;
        if (_CLIENT_CONNECT_WITH_DB in FCapabilities) then FCap:=FCap+CLIENT_CONNECT_WITH_DB;
        if (_CLIENT_NO_SCHEMA       in FCapabilities) then FCap:=FCap+CLIENT_NO_SCHEMA;
        if (_CLIENT_COMPRESS        in FCapabilities) then FCap:=FCap+CLIENT_COMPRESS;
        if (_CLIENT_ODBC            in FCapabilities) then FCap:=FCap+CLIENT_ODBC;
        if (_CLIENT_LOCAL_FILES     in FCapabilities) then FCap:=FCap+CLIENT_LOCAL_FILES;
        if (_CLIENT_IGNORE_SPACE    in FCapabilities) then FCap:=FCap+CLIENT_IGNORE_SPACE;

        with FUtility do begin
          Default_OnSelectDatabase     :=FOnSelectDatabase;
          Default_OnSelectDatabaseError:=FOnSelectDatabaseError;

          Default_OnCreateDatabase     :=FOnCreateDatabase;
          Default_OnCreateDatabaseError:=FOnCreateDatabaseError;

          Default_OnDropDatabase       :=FOnDropDatabase;
          Default_OnDropDatabaseError  :=FOnDropDatabaseError;

          Default_OnListDatabases      :=FOnListDatabases;
          Default_OnListDatabasesError :=FOnListDatabasesError;

          Default_OnListTables         :=FOnListTables;
          Default_OnListTablesError    :=FOnListTablesError;

          Default_OnListFields         :=FOnListFields;
          Default_OnListFieldsError    :=FOnListFieldsError;

          Default_OnListProcesses      :=FOnListProcesses;
          Default_OnListProcessesError :=OnListProcessesError;

          Default_OnPing               :=FOnPing;
          Default_OnPingError          :=FOnPingError;

          Default_OnShutdown           :=FOnShutdown;
          Default_OnShutdownError      :=FOnShutdownError;

          Default_OnKill               :=FOnKill;
          Default_OnKillError          :=FOnKillError;

          Default_OnOptions            :=FOnOptions;
          Default_OnOptionsError       :=FOnOptionsError;

          Default_OnRefresh            :=FOnRefresh;
          Default_OnRefreshError       :=FOnRefreshError;
        end;

        Utility.PrepareConnectTask(
          PChar(FHost),
          PChar(FUser),
          PChar(FPasswd),
          PChar(FDb),
          FPort,nil,FCap,
          'Connect to mySQL Server',
          _OnConnect,
          FOnConnectError
        );

        Execute;
      end;

      procedure   TCustom_mySQLClient.Connect(pHost: String);
      begin
        self.SetHostname(pHost);
        self.connect
      end;

      procedure   TCustom_mySQLClient.Connect(pHost: String; pPort: integer);
      begin
        self.SetHostname(pHost);
        self.SetPort(pPort);
        self.connect
      end;


      procedure TCustom_mySQLClient.ForceClose;
      begin
        if FConnected then begin
          BlockOnClose                :=TRUE;

          OnClose                     :=nil;
          OnConnectError              :=nil;
          OnStatus                    :=nil;
          FTaskHandler.Thread.OnStatus:=nil;

          FTaskHandler.DumpTasks;

          Close;
        end;
      end;

      procedure TCustom_mySQLClient.Close;
      var
        ThreadedTemp : boolean;
      begin
        if ((libmysql_status<>LIBMYSQL_READY) and (libmysql_status<>LIBMYSQL_INCOMPATIBLE)) or (not FConnected) then exit;

        if FTimedOut then begin
          _OnClose(Self);
          exit;
        end;

        StopTimer;

        ThreadedTemp:=Threaded;

        if BlockOnClose then
          Threaded:=FALSE;

        FTaskHandler.Thread.OnStatus:=nil;

        Utility.PrepareCloseTask(
          '[Session Closed]',
          _OnClose,
          nil
        );

        if FTaskHandler<>nil then
          FTaskHandler.StartTasks;

        if BlockOnClose then
          Threaded:=ThreadedTemp;

        FTimedOut:=FALSE;
        FConnected:=FALSE;
      end;

      procedure TCustom_mySQLClient.Execute;
      begin
        if FConnected then
          StopTimer;

        if FTimedOut then begin
          if Assigned(FOnStatus) then
            FOnStatus(Self,mysql_Status_Reconnecting,'[Reconnect]',0);

          Utility.PrepareConnectTask(
            PChar(FHost),
            PChar(FUser),
            PChar(FPasswd),
            PChar(FDb),
            FPort,nil,FCap,
            'Connect to mySQL Server',
            nil,
            FOnConnectError
          );
          FTimedOut:=FALSE;
        end;

        if FTaskHandler<>nil then
          FTaskHandler.StartTasks;
      end;

      procedure TCustom_mySQLClient.StartTimer;
      begin
        if FConnectedTimer=nil then exit;

        if FConnectedTimer.Enabled=FALSE then begin
          FConnectedTimer.Interval:=FConnectedTimeOutInterval;
          FConnectedTimer.OnTimer :=_OnTimeout;
          FTimedOut               :=FALSE;
          FConnectedTimer.Enabled :=TRUE;
        end;
      end;

      procedure TCustom_mySQLClient.StopTimer;
      begin
        if FConnectedTimer=nil then exit;

        if FConnectedTimer.Enabled=TRUE then
          FConnectedTimer.Enabled:=FALSE;
      end;

      procedure TCustom_mySQLClient._OnConnect(Sender: TObject);
      begin
        FConnected:=TRUE;

        Query :=CreateQuery; // ggf. zustzlich in eigener Methode!
        Modify:=CreateModify;

        if Assigned(FOnConnect) then
          FOnConnect(Self);
      end;

      procedure TCustom_mySQLClient._OnTimeout(Sender: TObject);
      var
        ThreadedTemp : boolean;
      begin
        FTimedOut:=TRUE;
        StopTimer;

        ThreadedTemp:=Threaded;

        if BlockOnClose then
          Threaded:=FALSE;

        Utility.PrepareCloseTask(
          '[Time Out: '+IntToStr(FConnectedTimeOutInterval)+']',
          nil,
          nil
        );

        if FTaskHandler<>nil then
          FTaskHandler.StartTasks;

        if BlockOnClose then
          Threaded:=ThreadedTemp;
      end;

      procedure TCustom_mySQLClient._OnTaskFinished(Sender: TObject);
      begin
        if FConnectedTimer=nil then exit;

        if (not FTimedOut) and (FConnected) then begin
          StopTimer;
          StartTimer;
        end;
      end;

      procedure TCustom_mySQLClient._OnClose(Sender: TObject);
      begin
        FConnected:=FALSE;
        FTimedOut:=FALSE;

        StopTimer;

        if Assigned(FOnClose) then
          FOnClose(Self);

        if (not FTimedOut) and (Assigned(FOnStatus)) then
          FOnStatus(Self,mysql_Status_NotConnected,'[Not Connected]',0);

        Query.Free;
        Query:=nil;

        Modify.Free;
        Modify:=nil;
      end;

      //----------------------------------------------------------------------------
      //----------------------------------------------------------------------------

      procedure TCustom_mySQLClient.SetDLLPath(const S : string);
      begin
        FDLLPath:=S;
      end;

      function  TCustom_mySQLClient.GetDLLPath : string;
      begin
        Result:=FDLLPath;
      end;

      procedure TCustom_mySQLClient.SetHostname(const S : string);
      begin
        FHost:=S;
      end;

      function  TCustom_mySQLClient.GetHostname : string;
      begin
        Result:=FHost;
      end;

      procedure TCustom_mySQLClient.SetUsername(const S : string);
      begin
        FUser:=S;
      end;

      function  TCustom_mySQLClient.GetUsername : string;
      begin
        Result:=FUser;
      end;

      procedure TCustom_mySQLClient.SetPassword(const S : string);
      begin
        FPasswd:=S;
      end;

      function  TCustom_mySQLClient.GetPassword : string;
      begin
        Result:=FPasswd;
      end;

      procedure TCustom_mySQLClient.SetDatabase(const S : string);
      begin
        Fdb:=S;
      end;

      function  TCustom_mySQLClient.GetDatabase : string;
      begin
        Result:=Fdb;
      end;

      procedure TCustom_mySQLClient.SetPort(const i : integer);
      begin
        FPort:=i;
      end;

      function  TCustom_mySQLClient.GetPort : integer;
      begin
        Result:=FPort;
      end;

      procedure TCustom_mySQLClient.SetCapabilities (const C : TSetClientCapabilities);
      begin
        FCapabilities:=C;
      end;

      function  TCustom_mySQLClient.GetCapabilities : TSetClientCapabilities;
      begin
        Result:=FCapabilities;
      end;

      procedure TCustom_mySQLClient.SetOnStatus(OS : TmySQLClientTask_OnStatus);
      begin
        FOnStatus:=OS;
        FTaskHandler.Thread.OnStatus:=OS;
      end;

      function  TCustom_mySQLClient.GetOnStatus : TmySQLClientTask_OnStatus;
      begin
        Result:=FOnStatus;
      end;

      function  TCustom_mySQLClient.GetThreaded : boolean;
      begin
        Result:=FThreaded;
      end;

      procedure TCustom_mySQLClient.SetThreaded(const b : boolean);
      begin
        FThreaded:=b;
        FTaskHandler.Threaded:=b;
      end;

      procedure Register;
      begin
        RegisterComponents('mySQLClient', [TmySQLClient]);
      end;

      //
      // Copyright (c) 1999 Justin P. Yunke and others...(see top)
      //



// -----------------------------------------------------------------------------------------------


constructor SQLErgebnisliste.init (pDatenbank : TCustom_mySQLClient);
begin
  kenntDatenbank:=pDatenbank;
end;

procedure SQLErgebnisliste.setzeGueltig;
begin
  prErfolgreich := Wahr;
  prAktuelleZeile := 1;
end;

procedure   SQLErgebnisliste.setzeUngueltig;
begin
  prErfolgreich := Falsch;
  prAktuelleZeile := 0;
end;

procedure   SQLErgebnisliste.vor;
begin
  if prErfolgreich then
      inc(prAktuelleZeile)
end;

procedure   SQLErgebnisliste.zumAnfang;
begin
  if prErfolgreich then
    prAktuelleZeile := 1;
end;

function    SQLErgebnisliste.zeilenanzahl : GanzeZahl;
begin
  if prErfolgreich then
    result := kenntDatenbank.Query.DataCount
  else
    result := 0
end;

function    SQLErgebnisliste.spaltenanzahl : GanzeZahl;
begin
  if prErfolgreich then
    result := kenntDatenbank.Query.FieldCount
  else
    result := 0
end;

function    SQLErgebnisliste.aktuelleZeile : GanzeZahl;
begin
  if prErfolgreich then
    result := prAktuelleZeile
  else
    result := 0
end;

function    SQLErgebnisliste.spaltentyp(pSpalte:GanzeZahl) : Zeichenkette;
begin
  if prErfolgreich and (pSpalte <=self.spaltenanzahl) then begin
     case kenntDatenbank.Query.Field[pSpalte-1]._type of
        FIELD_TYPE_DECIMAL     : result := 'Dezimalzahl';
        FIELD_TYPE_TINY        : result := 'Ganze Zahl [Tiny]';
        FIELD_TYPE_SHORT       : result := 'Ganze Zahl [Short]';
        FIELD_TYPE_LONG        : result := 'Ganze Zahl [Long]';
        FIELD_TYPE_FLOAT       : result := 'Fliekommazahl (einfache Genauigkeit)';
        FIELD_TYPE_DOUBLE      : result := 'Fliekommazahl (doppelte Genauigkeit)';
        FIELD_TYPE_NULL        : result := 'NULL';
        FIELD_TYPE_TIMESTAMP   : result := 'Zeitstempel';
        FIELD_TYPE_LONGLONG    : result := 'Ganze Zahl [longlong]';
        FIELD_TYPE_INT24       : result := 'Ganze Zahl [Int24]';
        FIELD_TYPE_DATE        : result := 'Datum';
        FIELD_TYPE_TIME        : result := 'Zeit';
        FIELD_TYPE_DATETIME    : result := 'Datum/Zeit';
        FIELD_TYPE_YEAR        : result := 'Jahr';
        FIELD_TYPE_NEWDATE     : result := 'Neues Datum';
        FIELD_TYPE_ENUM        : result := 'Liste';
        FIELD_TYPE_SET         : result := 'Menge';
        FIELD_TYPE_TINY_BLOB   : result := 'Tiny Blob';
        FIELD_TYPE_MEDIUM_BLOB : result := 'Medium Blob';
        FIELD_TYPE_LONG_BLOB   : result := 'Long Blob';
        FIELD_TYPE_BLOB        : result := 'Blob';
        FIELD_TYPE_VAR_STRING  : result := 'Var. Zeichenkette';
        FIELD_TYPE_STRING      : result := 'Zeichenkette';
        else result:='unbekannter Datentyp'
      end;

  end
end;

function    SQLErgebnisliste.spaltenbreite(pSpalte: GanzeZahl): GanzeZahl;
begin
  if prErfolgreich and (pSpalte <=self.spaltenanzahl) then
     result := kenntDatenbank.Query.Field[pSpalte-1].length
  else
     result := 0
end;

function    SQLErgebnisliste.spaltenname(pSpalte:GanzeZahl) : Zeichenkette;
begin
  if prErfolgreich and (pSpalte <=self.spaltenanzahl) then
    result := kenntDatenbank.Query.FieldName[pSpalte-1]
  else
    result := '';
end;

function    SQLErgebnisliste.istDahinter : Wahrheitswert;
begin
  if prErfolgreich then
    result := prAktuelleZeile > self.zeilenanzahl
  else
    result := true;
end;

function    SQLErgebnisliste.datenfeldAlsText(pDatenfeldname : Zeichenkette) : Zeichenkette;
begin
  if prErfolgreich and not (self.IstDahinter) then
    result := StrPas(kenntDatenbank.Query.DataByFieldName(prAktuelleZeile-1,pDatenfeldname))
  else
    result := '';
end;

function    SQLErgebnisliste.datenfeldAlsZahl(pDatenfeldname : Zeichenkette): Zahl;
var lCode: GanzeZahl;
    lWert: Zahl;
begin
  if prErfolgreich and not (self.IstDahinter) then
  begin
    {$R-}
    val(StrPas(kenntDatenbank.Query.DataByFieldName(prAktuelleZeile-1,pDatenfeldname)),lWert,lCode);
    {$R+}
    if lCode=0 then
      result := lWert
    else
      result := 0
  end
  else
    result := 0;
end;

function    SQLErgebnisliste.datenfeldAlsGanzeZahl(pDatenfeldname : Zeichenkette) : GanzeZahl;
var lCode: GanzeZahl;
    lWert: GanzeZahl;
begin
  if prErfolgreich and not (self.IstDahinter) then
  begin
    {$R-}
    val(StrPas(kenntDatenbank.Query.DataByFieldName(prAktuelleZeile-1,pDatenfeldname)),lWert,lCode);
    {$R+}
    if lCode=0 then
      result := lWert
    else
      result := 0
  end
  else
    result := 0;
end;

function    SQLErgebnisliste.datenfeldAlsText(pIndex : GanzeZahl) : Zeichenkette;
begin
  if prErfolgreich and (pIndex <=self.spaltenanzahl) and not (self.IstDahinter) then
    result := StrPas(kenntDatenbank.Query.Data(prAktuelleZeile-1,pIndex-1))
  else
    result := '';
end;

function    SQLErgebnisliste.datenfeldAlsZahl(pIndex : GanzeZahl) : Zahl;
var lCode: GanzeZahl;
    lWert: Zahl;
begin
  if prErfolgreich and (pIndex <=self.spaltenanzahl) and not (self.IstDahinter) then
  begin
    {$R-}
    val(StrPas(kenntDatenbank.Query.Data(prAktuelleZeile-1,pIndex-1)),lWert,lCode);
    {$R+}
    if lCode=0 then
      result := lWert
    else
      result := 0
  end
  else
    result := 0;
end;

function    SQLErgebnisliste.datenfeldAlsGanzeZahl(pIndex : GanzeZahl) : GanzeZahl;
var lCode: GanzeZahl;
    lWert: GanzeZahl;
begin
  if prErfolgreich and (pIndex <=self.spaltenanzahl) and not (self.IstDahinter) then
  begin
    {$R-}
    val(StrPas(kenntDatenbank.Query.Data(prAktuelleZeile-1,pIndex-1)),lWert,lCode);
    {$R+}
    if lCode=0 then
      result := lWert
    else
      result := 0
  end
  else
    result := 0;
end;

function    SQLErgebnisliste.alsTabelle: Zeichenkette;
var lTemp,lUnterstrich, lErgebnis : Zeichenkette;
    i,k    : GanzeZahl;

   function maxBreite(pSpaltennummer: integer): integer;
   begin
     if length(self.spaltenname(pSpaltennummer)) > self.spaltenbreite(pSpaltennummer) then
       result := length(self.spaltenname(pSpaltennummer))
     else
       result := self.spaltenbreite(pSpaltennummer)
   end;    

   function defTextBreite(pText: Zeichenkette; pBreite: GanzeZahl): Zeichenkette;
   begin
     pText := Copy(pText,1,pBreite);
     while length(pText)<pBreite do
       pText:=pText+' ';
     result:=pText
   end;
begin
  lErgebnis:='';
  if self.spaltenAnzahl>0 then
  begin
    lTemp:=' |';
    lUnterstrich:=' |';
    for i:=1 to self.spaltenAnzahl do
    begin
      lTemp:=lTemp+defTextBreite(self.spaltenname(i),maxBreite(i))+'|';
      lUnterstrich:=lUnterstrich+ StringOfChar('-',maxBreite(i))+'|';
    end;

    lErgebnis := lErgebnis+lTemp+#13#10;
    lErgebnis := lErgebnis+lUnterstrich+#13#10;

    self.zumAnfang;
    for i:=1 to self.zeilenanzahl do
    begin
      lTemp := ' |';
      for k:=1 to self.spaltenanzahl do
        lTemp:=lTemp+defTextBreite(self.datenfeldAlsText(k),maxBreite(k))+'|';
      self.vor;
      lErgebnis:=lErgebnis+lTemp+#13#10;
    end;
  end;
  result := lErgebnis;
end;

destructor  SQLErgebnisliste.gibFrei;
begin
  kenntDatenbank.Query.free;
  inherited;
end;

// -----------------------------------------------------------------------------------------------

constructor Datenbank.init(eigentuemer: komponente);
begin
  inherited Create(eigentuemer);
  hatTextwerkzeug := Textwerkzeug.init;
  hatTextwerkzeug.setzeTrennung(' ');
  hatSQLErgebnis:= SQLErgebnisliste.init(self);
  zAktuelleZeile:= 0;
end;

function    Datenbank.istVerbunden: Wahrheitswert;
begin
  result := Connected
end;

function   Datenbank.verbinde(pDatenbank, pTreiber, pAnbindung, pUser, pPasswort : Zeichenkette): Zeichenkette;
begin
  // von dieser Klasse werden nur Verbindungen zu MySQL-Servern untersttzt!
  // verwende hier als Default-Server localhost
  result := self.verbindeMySQL(pDatenbank,'localhost',pUser,pPasswort);
end;

function   Datenbank.verbindeMySQL(pDatenbank, pServer: Zeichenkette; pPort: GanzeZahl; pUser, pPasswort : Zeichenkette): Zeichenkette;
begin
  if not self.Connected then
  begin
    zFehler:=Falsch;
    zVerbindungAufgebaut:=Falsch;
    Database := pDatenbank;
    Username := pUser;
    Password := pPasswort;
    Threaded := False;
    BlockOnClose := True;
    OnConnect := self.dbverbunden;
    OnConnectError:= self.dbfehler;
    inherited Connect(pServer,pPort);
    repeat
      Yield
    until zVerbindungAufgebaut or zFehler;
    if zFehler then
      result := zFehlermeldung
    else
      result := '';
  end else
    result := 'Es existiert bereits eine Datenverbindung. Trennen Sie diese Verbindung vor dem Aufbau einer neuen Verbindung!';
end;

function   Datenbank.verbindeMySQL(pDatenbank, pServer, pUser, pPasswort : Zeichenkette): Zeichenkette;
begin
  result := self.verbindeMySQL(pDatenbank,pServer,MYSQL_PORT,pUser,pPasswort)
end;

procedure   Datenbank.trenne;
begin
  inherited Close
end;

function    Datenbank.datenbankinfo: Zeichenkette;
begin
  if Connected then
  result :=
    'Versionsinformation Server: '+self.Utility.ServerInfo+#13#10+
    'Versionsinformation Client: '+self.Utility.ClientInfo+#13#10+
    'Rechner:                    '+self.Utility.HostInfo+#13#10+
    'Serverstatus: '+self.Utility.Stat+#13#10+
    'Aktuelle Datenbank: '+Database
  else
    result:='Keine Verbindung zum Datenbankserver.';  
end;

function    Datenbank.tabellenName(pNummer: GanzeZahl) : Zeichenkette;
begin
  if Connected then begin
    Utility.PrepareListTables('%','Show Tables');
    Execute;
    if pNummer <= Utility.ListResult.Count then
      result := Utility.ListResult.Strings[pNummer-1]
    else
      result := 'Indexfehler! Es gibt in der Datenbank keine Tabelle mit dem Index '+IntToStr(pNummer)+'!'
  end else
    fehler('Programmierfehler: Abfrage eines Tabellennamens bei nicht verbundener Datenbank!')
end;

function    Datenbank.tabellenAnzahl : GanzeZahl;
begin
  if self.Connected then begin
    Utility.PrepareListTables('%','Show Tables');
    Execute;
    result := Utility.ListResult.Count
  end
  else
  begin
    fehler('Programmierfehler: Abfrage der Anzahl Tabellen bei nicht verbundener Datenbank!');
    result := 0
  end;
end;

procedure   Datenbank.setzeTransaktionsStatus(pStatus : GanzeZahl);
begin
  // noch nicht implementiert, aus der Dokumentation entfernt
  self.fehler('Transaktionen werden von der Datenbankkomponente noch nicht untersttzt.');
end;

procedure   Datenbank.setzeAenderungsStatus(pStatus : Wahrheitswert);
begin
  // noch nicht implementiert
  self.fehler('Das Setzen des nderungsstatus wird von der Datenbankkomponente noch nicht untersttzt.');
end;

procedure   Datenbank.datenbankAendern(pSQL : Zeichenkette);
begin
  Modify.PrepareModifySQLTask(pSQL, 'ndern',SQLAusgefuehrt,SQLFehler);
  self.Execute;
end;

procedure   Datenbank.aenderungenAufnehmen;
begin
  // noch nicht implementiert
  self.fehler('Das Aufnehmen von nderungen wird von der Datenbankkomponente noch nicht untersttzt.');
end;

function    Datenbank.ergebnis : SQLErgebnisliste;
begin
  result := hatSQLErgebnis
end;

function    Datenbank.sendeSQL(pSQL : Zeichenkette) : Zeichenkette;
var lZeichenkette: PChar;
begin
  lZeichenkette := AllocMem(length(pSQL)+1);
  StrPCopy(lZeichenkette,pSQL);
  Query.Reset;
  Query.PrepareTask(lZeichenkette, 'Abfrage', SQLAusgefuehrt, SQLFehler);
  zAusgefuehrt := Falsch;
  Execute;
  // FEHLER???
  repeat
    Yield
  until zAusgefuehrt;
  result := zFehlermeldung;
  FreeMem(lZeichenkette);
end;

procedure   Datenbank.SQLFehler(sender: tobject; nachricht: string);
begin
  // MessageDlg('Datenbankfehler: '+nachricht,mtError,[mbOk],0);
  zAusgefuehrt := Wahr;
  zFehler := Wahr;
  zFehlermeldung := nachricht;
  ergebnis.setzeUngueltig;
end;

procedure   Datenbank.SQLAusgefuehrt(sender: tobject);
begin
//  MessageDlg('Datenbank verbunden',mtInformation,[mbOk],0);
  zAusgefuehrt := Wahr;
  zFehler := Falsch;
  zFehlermeldung := '';
  ergebnis.setzeGueltig;
end;


procedure   Datenbank.dbfehler(sender: tobject; nachricht: string);
begin
  // MessageDlg('Datenbankfehler: '+nachricht,mtError,[mbOk],0);
  zFehlermeldung := nachricht;
  zFehler := Wahr;
  ergebnis.setzeUngueltig;
end;

procedure   Datenbank.fehler(nachricht: string);
begin
  MessageDlg(nachricht,mtError,[mbOk],0);
end;

procedure   Datenbank.dbverbunden(sender: tobject);
begin
  //  MessageDlg('Datenbank verbunden',mtInformation,[mbOk],0);
  zVerbindungAufgebaut := Wahr;
  zFehler := Falsch;
  ergebnis.setzeUngueltig;
end;

destructor  Datenbank.gibFrei;
begin
  inherited Destroy;
end;

// -----------------------------------------------------------------------------------------------
// Hier noch die Routinen zum Laden und Freigeben der DLL
// Quelle: mySQL.pas
  
// -----------------------------------------------------------------------------------------------
INITIALIZATION
// -----------------------------------------------------------------------------------------------

begin
  {$IFNDEF DONT_LOAD_DLL}
  libmysql_load(nil);
  {$ENDIF} // DONT_LOAD_DLL
end;

// -----------------------------------------------------------------------------------------------
FINALIZATION
// -----------------------------------------------------------------------------------------------

begin
  libmysql_free;
end;

end.
